#include <sys/types.h>
#include <sys/mman.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define SHMSZ     		27
#define DAILYLOAD_IDX		100
#define LOADBALANCE_IDX		130
#define TOTALLOAD_IDX		40

extern "C"
{


void initialize(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	int* shmidInput;
	int* shmidOutput;
	key_t key;
	double initv[] = {97.6,322,500,233.8,522,6.5,8.53,320,329,158,680,274,247.5,308.6,224,139,281,206,283.5,9.2,1104};

	genr[ 40 ] = 97.6;
	genr[ 41 ] = 322;
	genr[ 42 ] = 500;
	genr[ 43 ] = 233.8;
	genr[ 44 ] = 522;
	genr[ 45 ] = 6.5;
	genr[ 46 ] = 8.53;
	genr[ 47 ] = 320;
	genr[ 48 ] = 329;
	genr[ 49 ] = 158;
	genr[ 50 ] = 680;
	genr[ 51 ] = 274;
	genr[ 52 ] = 247.5;
	genr[ 53 ] = 308.6;
	genr[ 54 ] = 224;
	genr[ 55 ] = 139;
	genr[ 56 ] = 281;
	genr[ 57 ] = 206;
	genr[ 58 ] = 283.5;
	genr[ 59 ] = 9.2;
	genr[ 60 ] = 1104;

	// Init DL (Daily Load) & LB (Load Balance) memory regions
	for ( int i = 0 ; i < 21 ; ++i ) {
		genr[DAILYLOAD_IDX+i] = initv[i];
		genr[LOADBALANCE_IDX+i] = 0;
	} 
}

void execStep(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	/*static int ctr = 0;
	++ctr;
	if ( ctr > 50 ) {
		printf("VAL: %f\n", genr[DAILYLOAD_IDX] );
		ctr = 0;
	}*/

	// Add the daily load to the load balance and feed it to the model input
	for ( int i = 0 ; i < 21 ; ++i ) {
		genr[TOTALLOAD_IDX+i] = genr[DAILYLOAD_IDX+i] + genr[LOADBALANCE_IDX+i]; 
	}
}

void getRequiredReadRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}

void getRequiredWriteRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}

} //extern "C"
