// Simmulator Inputs (coils)
#define RIVER_VALVE		0
#define TANK2_INVALVE	1
#define TANK2_OUTVALVE	2

// Simmulator Outputs (input registers)
#define FUEL_VALVE		0
#define STEAM_VALVE		1
#define WATER_VALVE		2

#define OUTPUT_INDEX		12

double g_setpts[ 41 ];


#include <stdio.h>
extern "C"
{

void initialize(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	for ( int i = 0 ; i < 40 ; ++i )
	{
		g_setpts[ i ] = 0;
	}
	
	g_setpts[ 19 ] = 341.765420;
	
	genr[ 4 ] = 22.21;
}

static int g_counter = 0;
void execStep(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	++g_counter;
	if ( g_counter >= 138 )
	{
		// Calculate new valve position
		static double prev_err_v = 0;
		const double Kc_v = 0.036;
		const double Ts_v = 0.1; //72micro - the time step
		const double Ti_v = 20*60; //seconds
		double err1 = g_setpts[ 19 ] - genr[ OUTPUT_INDEX + 19 ];
		genr[ 4 ] = genr[ 4 ] + Kc_v * ( err1 - prev_err_v + (Ts_v / Ti_v)*err1 );
		prev_err_v = err1;
		
		g_counter = 0;
		
		if ( genr[ 4 ] > 100 ) {
			genr[ 4 ] = 100;
		}
		if ( genr[ 4 ] < 0 ) {
			genr[ 4 ] = 0;
		}

	}
}

void getRequiredReadRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}

void getRequiredWriteRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}


} //extern "C"
