// Simmulator Inputs (coils)
#define RIVER_VALVE		0
#define TANK2_INVALVE	1
#define TANK2_OUTVALVE	2

// Simmulator Outputs (input registers)
#define FUEL_VALVE		0
#define STEAM_VALVE		1
#define WATER_VALVE		2

#define OUTPUT_INDEX		12

double g_setpts[ 41 ];

#include <stdio.h>
extern "C"
{

FILE* g_pf = NULL;
static bool g_shutdown = false;
void initialize(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	g_pf = fopen( "shutdown.txt", "wt" );
	fprintf( g_pf, "RUNNING\n" );
	fflush( g_pf );
}


void execStep(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	static double v[ 10 ] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	static int ctr = 0;
	++ctr;
	
	if ( ctr < 1500 ) {
		return;
	}
	ctr = 0;
	
	if ( !g_shutdown )
	{
		if ( 0 == v[ 0 ] && 0 == v[ 1 ] )
		{
			for ( int i = 0 ; i < 10 ; ++i )
			{
				v[ i ] = genr[ OUTPUT_INDEX + i ];
			}
		}
		else {
			bool eq = false;
			int count = 0;
			for ( int i = 0 ; i < 10 ; ++i )
			{
				if ( v[ i ] == genr[ OUTPUT_INDEX + i ] ) {
					++count;
				}
				
				if ( count >= 5 ) {
					eq = true;
					break;
				}
			}
			if ( !eq )
			{
				for ( int i = 0 ; i < 10 ; ++i )
				{
					v[ i ] = genr[ OUTPUT_INDEX + i ];
				}
			}
			else {
				g_shutdown = true;
				fprintf(g_pf, "SHUTDOWN!\n");
				fflush( g_pf );
				fclose( g_pf );
			}
		}
	}
}

void getRequiredReadRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}

void getRequiredWriteRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}


} //extern "C"
