#!/usr/bin/perl
use File::Copy;

sub index_extr
{
	my @srcarray = split(';', $_[0]);
	my @result;

	foreach my $val (@srcarray) {
        	if ( $val =~ /-/ ) {
                	my @tmparray = split('-', $val);

			for ( $j = ${tmparray[0]} ; $j <= ${tmparray[1]} ; ++$j ) {
				print "Add: $j\n";
                        	push(@result, "$j");
                	}
        	}
        	else {
			print "Add*: $val\n";
                	push(@result, "$val");
        	}
	}

	return @result;
}

if (($ARGV[0] eq "") or ($ARGV[0] eq "-h")) {
  print "Arguments:\n";
  print "0 - Name of the model (e.g. DecisionAlgorithm)\n";
  print "1 - Path of MALTAB_ROOT in mk file without / at the end (e.g. ../MATLAB_ROOT)\n";
  print "2 - Initial path of the model in mk file (e.g. ./)\n";
  print "3 - COMPUTER in mk file (GNLXA32/GNLXA64 for GNU Linux 32/64 bit, PCWIN32/PCWIN64 for Windows 32/64 bit)\n";
  print "4 - Type of registers to share data with RPLC, possible values: holdingreg, genreg\n";
  print "5 - List of model inputs to share by TCC, separated by ';' or a range separated by '-' (e.g. \"0;10;20;25-30;\")\n";
  print "6 - List of model outputs to share by TCC, separated by ';' or a range separated by '-' (e.g. \"0;10;20;25-30;\")\n";
  print "7 - List of model inputs to share by RPC, separated by ';' or a range separated by '-' (e.g. \"0;10;20;25-30;\", for 0 inputs write \"\")\n";
  print "8 - List of model outputs to share by RPC, separated by ';' or a range separated by '-' (e.g. \"0;10;20;25-30;\", for 0 outputs write \"\")\n";
  print "9 - List of model inputs to share by shared memory, separated by ';' or a range separated by '-' (e.g. \"0;10;20;25-30;\", for 0 inputs write \"\")\n";
  print "10 - List of model outputs to share by shared memory, separated by ';' or a range separated by '-' (e.g. \"0;10;20;25-30;\", for 0 outputs write \"\")\n";
  print "11 - Shared memory ID for the first Input, it must be an integer > 0 (e.g. 5000)\n";
  print "(The InitialValues file must also be present)\n";
  exit;
}

$ModelName = $ARGV[0]; #DecisionAlgorithmCorrect
$Matlab_Root = $ARGV[1]; #../MATLAB_ROOT
$StartDir = $ARGV[2]; #./
$Computer = $ARGV[3]; #GNLXA32
$register = $ARGV[4]; #holdingreg
$plctosim = $ARGV[5]; #"6;19;20;11;19;"
$simtoplc = $ARGV[6]; #"19;33;"
$rpctosim = $ARGV[7]; #"6;19;20;11;19;"
$simtorpc = $ARGV[8]; #"19;33;"
$shmtosim = $ARGV[9]; #"6;19;20;11;19;"
$simtoshm = $ARGV[10]; #"19;33;"
$shmkey = $ARGV[11]; #5000
#./automatization.pl DecisionAlgorithmCorrect ../MATLAB_ROOT ./ GNLXA32 holdingreg "6;19;20;11;19;" "19;33;" "6;19;20;11;19;" "19;33;" "6;19;20;11;19;" "19;33;" 5000

if ($register eq "holdingreg") {
  $stype = "unsigned short";
}
else {
  $stype = "double";
}

$outdir = "Output";
system('rm','-r',$outdir);
system('mkdir', $outdir);

#Read number of input/output, name of structures from file {ModelName}.h 
$ModelName_bck = "${ModelName}_ORI";

open FILE, "./${ModelName}_grt_rtw/${ModelName}.h" or die $!;
$status = 0;
@InputVariableName = ();
@OutputVariableName = ();

my @simtoplcarray = index_extr($simtoplc);
my @plctosimarray = index_extr($plctosim);

$nsimtoplc = scalar(@simtoplcarray);
$nplctosim = scalar(@plctosimarray);

if ($shmtosim eq "") {
  $nshmtosim = 0;
}
else {
  @shmtosimarray = index_extr($shmtosim);
  $nshmtosim = scalar(@shmtosimarray);

	print "*** NSHM= $nshmtosim\n";
}

if ($simtoshm eq "") {
  $nsimtoshm = 0;
}
else {
  @simtoshmarray = index_extr($simtoshm);
  $nsimtoshm = scalar(@simtoshmarray);
}

if ($rpctosim eq "") {
  $nrpctosim = 0;
}
else {
  @rpctosimarray = index_extr($rpctosim);
  $nrpctosim = scalar(@rpctosimarray);
}

if ($simtorpc eq "") {
  $nsimtorpc = 0;
}
else {
  @simtorpcarray = index_extr($simtorpc);
  $nsimtorpc = scalar(@simtorpcarray);
}

$InputStructure = '';
$OutputStructure = '';

while (<FILE>) {
  $control = substr $_, 0, 18;
  if ($control eq "/* External inputs") {
    $status = 1;
  }

  $control = substr $_, 0, 17;
  if ($control eq "} ExternalInputs_") {
    $InputStructure = substr $_, 2, (length($_) - 5);
    #print "${InputStructure}\n";
    $status = 0;
  }

  $control = substr $_, 0, 19;
  if ($control eq "/* External outputs") {
    $status = 2;
  }

  $control = substr $_, 0, 18;
  if ($control eq "} ExternalOutputs_") {
    $OutputStructure = substr $_, 2, (length($_) - 5);
    #print "${OutputStructure}\n";
    $status = 0;
  }

  $control = substr $_, 43, 6;

  if ($control eq "<Root>") {
    $tmp = substr $_, 50;
    @ar = split('\'', $tmp);
    $tmpname = @{ar[0]};
    $tmpname =~ s/ //g;

    if ($status == 1) {
      $n1 = index($_, "[");
      $n2 = index($_, "]");
      if ($n1 >= 0) {
        $length = substr $_, $n1 + 1, ($n2 - $n1 - 1);
        #print "length = $length \n";

        for($i = 0; $i < $length; $i++) {
	  push(@InputVariableName, "${tmpname}[$i]");
        }
      }
      else {
        $length = 1;
	push(@InputVariableName, $tmpname);
      }
      
      $NumModelInputs = $NumModelInputs + $length;
      #print "NumModelInputs = $NumModelInputs\n";
    }

    if ($status == 2) {
      $n1 = index($_, "[");
      $n2 = index($_, "]");
      if ($n1 >= 0) {
        $length = substr $_, $n1 + 1, ($n2 - $n1 - 1);
        #print "length = $length \n";

        for($i = 0; $i < $length; $i++) {
	  push(@OutputVariableName, "${tmpname}[$i]");
        }
      }
      else {
        $length = 1;
	push(@OutputVariableName, $tmpname);
      }

      $NumModelOutputs = $NumModelOutputs + $length;
      #print "NumModelOutputs = $NumModelOutputs\n";
    }
  }
}

close(FILE);

print "Structure names read\n";



#Read name of variables from file {ModelName}.c
$nI = length $InputStructure;
$nO = length $OutputStructure;

open FILE, "./${ModelName}_grt_rtw/${ModelName}.c" or die $!;

while (<FILE>) {
  $control = substr $_, 0, $nI;
  if ($control eq $InputStructure) {
    if ($nI > 0) {
      @ar = split(';', substr $_, ($nI + 1));
      $InputVariable = @{ar[0]};
      #print "$InputVariable\n"; 
    }
  }

  $control = substr $_, 0, $nO;
  if ($control eq $OutputStructure) {
    if ($nO > 0) {
      @ar = split(';', substr $_, ($nO + 1));
      $OutputVariable = @{ar[0]};
      #print "$OutputVariable\n";
    }
  }
}

close(FILE);

print "Variable names read\n";



#Modifications of .mk file
copy("./${ModelName}_grt_rtw/${ModelName}.mk","./${ModelName}_grt_rtw/${ModelName_bck}.mk") or die "Copy failed: $!";

open MKFILE, "./${ModelName}_grt_rtw/${ModelName_bck}.mk" or die $!;
open(MKFILE_OUT,">./${ModelName}_grt_rtw/${ModelName}.mk"); 

while (<MKFILE>) {
  $oldline = $_;
  $oldline =~ s/grt_main.c/grt_shell.c/g;
  $n1 = index($oldline, "=");
  $firstpart = substr $oldline, 0, $n1;
  $secondpart = substr $oldline, ($n1 + 1);
  $trimfirstpart = $firstpart;
  $trimfirstpart =~ s/ //g;

  if ($trimfirstpart eq "MATLAB_ROOT") {
	$newline = "${firstpart}= $Matlab_Root\n";
	#print $newline;
	print MKFILE_OUT "$newline"; 
  }
  elsif ($trimfirstpart eq "ALT_MATLAB_ROOT") {
	$newline = "${firstpart}= $Matlab_Root\n";
	#print $newline; 
	print MKFILE_OUT "$newline"; 
  }
  elsif ($trimfirstpart eq "START_DIR") {
	$newline = "${firstpart}= ${StartDir}\n";
	#print $newline; 
	print MKFILE_OUT "$newline"; 
  }
  elsif ($trimfirstpart eq "COMPUTER") {
	$newline = "${firstpart}= ${Computer}\n";
	#print $newline; 
	print MKFILE_OUT "$newline"; 
  }
  elsif ($trimfirstpart eq "CFLAGS") {
	$newline = "${firstpart}= -fPIC ${secondpart}\n";
	#print $newline; 
	print MKFILE_OUT "$newline"; 
  }
  elsif ($trimfirstpart eq "CPPFLAGS") {
	$newline = "${firstpart}= -fPIC ${secondpart}\n";
	#print $newline; 
	print MKFILE_OUT "$newline"; 
  }
  else {
	print MKFILE_OUT $oldline; 
  }
}

close(MKFILE);
close (MKFILE_OUT);

print "File ${ModelName}.mk modified\n";



#Creation and compilation of grt_shell.c
copy("./empty","./${ModelName}_grt_rtw/grt_shell.c") or die "Copy failed: $!";

open FILE, "./grt_shell_template.c" or die $!;
open(FILE_OUT,">./${ModelName}_grt_rtw/grt_shell.c") or die "Open file failed: $!"; 

while (<FILE>) {
  $line = $_;

  $jump = 0;

  if (($line =~ /INPUTSTRUCTURE/) && ($nI == 0)) {
    $jump = 1;
  }
  else {
    $line =~ s/INPUTSTRUCTURE/$InputStructure/g;
    $line =~ s/INPUTVARIABLES/$InputVariable/g;
  }

  if (($line =~ /OUTPUTSTRUCTURE/) && ($nO == 0)) {
    $jump = 1;
  }
  else {
    $line =~ s/OUTPUTSTRUCTURE/$OutputStructure/g;
    $line =~ s/OUTPUTVARIABLES/$OutputVariable/g;
  }

  if ($line =~ /NUMIN/) {
    for($i = 0; $i < $NumModelInputs; $i++) {
      $linemod = $line;
      $linemod =~ s/NUMIN/$i/g;
      $linemod =~ s/INPUTNAME/@{InputVariableName[$i]}/g;
      #print "$linemod";
      print FILE_OUT "$linemod" or die "Print failed: $!"; 
    }
  }
  elsif ($line =~ /NUMOUT/) {
    for($i = 0; $i < $NumModelOutputs; $i++) {
      $linemod = $line;
      $linemod =~ s/NUMOUT/$i/g;
      $linemod =~ s/OUTPUTNAME/@{OutputVariableName[$i]}/g;
      #print "$linemod";
      print FILE_OUT "$linemod" or die "Print failed: $!"; 
    }
  }
  elsif ($jump == 0) {
    print FILE_OUT "$line" or die "Print failed: $!"; 
  }
}

close(FILE);
close (FILE_OUT);

chdir("./${ModelName}_grt_rtw/");
system("rm *.o");
system("rm *.so");
system("make -f $ModelName.mk");
system("ld -shared *.o -soname ${ModelName} -o ${ModelName}.so");

print("File ${ModelName}.so created\n");

chdir("../");

system("cp ./${ModelName}_grt_rtw/${ModelName}.so Output/${ModelName}.so");

print "File grt_shell.c created\n";



#Creation and compilation of TCC.cpp
@val_tcc = ();

open FILE, "./InitialValues" or die $!;

while (<FILE>) {
  $len = length $_;
  if ($len > 0) {
    $line = substr $_, 0, ($len - 1);
    push(@val_tcc, $line)
  }
}

close(FILE);

copy("./empty","./$outdir/TCC.cpp") or die "Copy failed: $!";

open FILE, "./TCC_template.cpp" or die $!;
open(FILE_OUT,">./$outdir/TCC.cpp"); 

while (<FILE>) {
  $line = $_;
  $line =~ s/NUMINPUT/$nplctosim/g;
  $line =~ s/NUM_SHARMEM_INPUTS/$nplctosim/g;
  $line =~ s/NUM_SHARMEM_OUTPUTS/$nsimtoplc/g;
  
  if ($line =~ /VAR/) {
  }
  elsif ($line =~ /REGISTERINPUT/) {
    for($i = 0; $i < $nplctosim; $i++) {
      if ($register eq "holdingreg") {
        $index_reg = $nsimtoplc + $i;
        $index_value = ${plctosimarray[$i]};
        print FILE_OUT "	hr[ $index_reg ] = ${val_tcc[$index_value]};\n"
      }
      else {
        $index_reg = $nsimtoplc + $i;
        $index_value = ${plctosimarray[$i]};
        print FILE_OUT "	genr[ $index_reg ] = ${val_tcc[$index_value]};\n"
      }
    }
  }
  elsif ($line =~ /SHARMEM_REGISTERS/) {    
  }
  elsif ($line =~ /SHARMEM_READWRITE/) {
  }
  else {
	print FILE_OUT $line; 
  }
}

close(FILE);
close (FILE_OUT);

system("g++ $outdir/TCC.cpp -shared -fPIC -o $outdir/TCC.so");

print("File $outdir/TCC.so created\n");



#Creation and compilation of TCC_shm.cpp
copy("./empty","./$outdir/TCC_shm.cpp") or die "Copy failed: $!";

open FILE, "./TCC_template.cpp" or die $!;
open(FILE_OUT,">./$outdir/TCC_shm.cpp"); 

while (<FILE>) {
  $line = $_;
  $line =~ s/NUMINPUT/$nshmtosim/g;
  
  if ($line =~ /VAR/) {
	print FILE_OUT "$stype* shmInput;\n";
	print FILE_OUT "$stype* shmOutput;\n";
  }
  elsif ($line =~ /REGISTERINPUT/) {
    for($i = 0; $i < $nshmtosim; $i++) {
      if ($register eq "holdingreg") {
        $index_reg =  $nsimtoplc + $nplctosim + $nsimtorpc + $nrpctosim + $i;
        $index_value = ${shmtosimarray[$i]};
        print FILE_OUT "	hr[ $index_reg ] = ${val_tcc[$index_value]};\n"
      }
      else {
        $index_reg = $i;
        $index_reg =  $nsimtoplc + $nplctosim + $nsimtorpc + $nrpctosim + $i;
        $index_value = ${shmtosimarray[$i]};
        print FILE_OUT "	genr[ $index_reg ] = ${val_tcc[$index_value]};\n"
      }
    }
  }
  elsif ($line =~ /SHARMEM_REGISTERS/) {    
	print FILE_OUT "	key = $shmkey;\n";
	print FILE_OUT "	if ((shmidInput = shmget(key, $nshmtosim*sizeof($stype), IPC_CREAT | 0666)) < 0) {\n";
	print FILE_OUT "		perror(\"shmget\");\n";
	print FILE_OUT "		exit(1);\n";
	print FILE_OUT "	}\n";
	print FILE_OUT "	if ((shmInput = ($stype*)shmat(shmidInput, NULL, 0)) == ($stype*) -1) {\n";
	print FILE_OUT "		perror(\"shmat\");\n";
	print FILE_OUT "		exit(1);\n";
	print FILE_OUT "	}\n \n";
      
	if ( $nsimtoshm > 0 ) {
		$shmkey = $shmkey + 1;
		print FILE_OUT "	key = $shmkey;\n";
		print FILE_OUT "	if ((shmidOutput = shmget(key, $nsimtoshm*sizeof($stype), IPC_CREAT | 0666)) < 0) {\n";
		print FILE_OUT "		perror(\"shmget\");\n";
		print FILE_OUT "		exit(1);\n";
		print FILE_OUT "	}\n";
		print FILE_OUT "	if ((shmOutput = ($stype*)shmat(shmidOutput, NULL, 0)) == ($stype*) -1) {\n";
		print FILE_OUT "		perror(\"shmat\");\n";
		print FILE_OUT "		exit(1);\n";
		print FILE_OUT "	}\n \n";
	}
     
     for($i = 0; $i < $nshmtosim; $i++) {
       if ($register eq "holdingreg") {
         $index_reg = $i;
         $index_value = ${shmtosimarray[$i]};
         print FILE_OUT "	shmInput[ $index_reg ] = ${val_tcc[$index_value]};\n"
       }
       else {
         $index_reg = $i;
         $index_value = ${shmtosimarray[$i]};
         print FILE_OUT "	shmInput[ $index_reg ] = ${val_tcc[$index_value]};\n"
       }
     }
  }
  elsif ($line =~ /SHARMEM_READWRITE/) {
    $k = -1;
    for($i = 0; $i < $nshmtosim; $i++) {
      $k = $k + 1;
      $idx_k = $nsimtoplc + $nplctosim + $nsimtorpc + $nrpctosim + $k;
      if ($register eq "holdingreg") {
        print FILE_OUT "	hr[ $idx_k ] = shmInput[ $i ];\n";
      }
      else {
        print FILE_OUT "	genr[ $idx_k ] = shmInput[ $i ];\n";
      }
    }	
    for($i = 0; $i < $nsimtoshm; $i++) {
      $k = $k + 1;
      $idx_k = $nsimtoplc + $nplctosim + $nsimtorpc + $nrpctosim + $k;
      if ($register eq "holdingreg") {
        print FILE_OUT "	shmOutput[ $i ] = hr[ $idx_k ];\n";
      }
      else {
        print FILE_OUT "	shmOutput[ $i ] = genr[ $idx_k ];\n";
      }
    }
  }
  else {
	print FILE_OUT $line; 
  }
}

close(FILE);
close (FILE_OUT);

system("g++ $outdir/TCC_shm.cpp -shared -fPIC -o $outdir/TCC_shm.so");

print("File $outdir/TCC_shm.so created\n");



#Creation of .xml file
copy("./empty","./$outdir/FDServerConfig.xml") or die "Copy failed: $!";

open FILE, "./FDServerConfig_template.xml" or die $!;
open(FILE_OUT,">./$outdir/FDServerConfig.xml") or die "Open file failed: $!"; 

$k = -1;
$emptystring = "";

while (<FILE>) {
  $line = $_;

  $line =~ s/INPUTNUMBER/$NumModelInputs/g;
  $line =~ s/OUTPUTNUMBER/$NumModelOutputs/g;
  $line =~ s/REGISTER/$register/g;

  $nval_tcc = scalar(@val_tcc);

  if ($line =~ /INPUTVALUES/) {
    for($i = 0; $i < $nval_tcc; $i++) {
      print FILE_OUT "        <input address=\"$i\" value=\"${val_tcc[$i]}\"/>\n"
    }
  }
  elsif ($line =~ /MAPSIMTOPLC/) {
    for($i = 0; $i < $nsimtoplc; $i++) {
      $k = $k + 1;
      print FILE_OUT "    <map direction=\"simtoplc\" type=\"analog\">\n";
      print FILE_OUT "      <src address=\"@{simtoplcarray[$i]}\"/>\n";
      print FILE_OUT "      <dest address=\"${k}\" mem=\"${register}\"/>\n";
      print FILE_OUT "    </map>\n";
    }
  }
  elsif ($line =~ /MAPPLCTOSIM/) {
    for($i = 0; $i < $nplctosim; $i++) {
      $k = $k + 1;
      print FILE_OUT "    <map direction=\"plctosim\" type=\"analog\">\n";
      print FILE_OUT "      <src address=\"${k}\" mem=\"${register}\"/>\n";
      print FILE_OUT "      <dest address=\"@{plctosimarray[$i]}\"/>\n";
      print FILE_OUT "    </map>\n";
    }
  }
  elsif ($line =~ /MAPSIMTORPC/) {
    for($i = 0; $i < $nsimtorpc; $i++) {
      $k = $k + 1;
      print FILE_OUT "    <map direction=\"simtoplc\" type=\"analog\">\n";
      print FILE_OUT "      <src address=\"@{simtorpcarray[$i]}\"/>\n";
      print FILE_OUT "      <dest address=\"${k}\" mem=\"${register}\"/>\n";
      print FILE_OUT "    </map>\n";
    }
  }
  elsif ($line =~ /MAPRPCTOSIM/) {
    for($i = 0; $i < $nrpctosim; $i++) {
      $k = $k + 1;
      print FILE_OUT "    <map direction=\"plctosim\" type=\"analog\">\n";
      print FILE_OUT "      <src address=\"${k}\" mem=\"${register}\"/>\n";
      print FILE_OUT "      <dest address=\"@{rpctosimarray[$i]}\"/>\n";
      print FILE_OUT "    </map>\n";
    }
  }
  elsif ($line =~ /MAPSIMTOSHM/) {
    for($i = 0; $i < $nsimtoshm; $i++) {
      $k = $k + 1;
      print FILE_OUT "    <map direction=\"simtoplc\" type=\"analog\">\n";
      print FILE_OUT "      <src address=\"@{simtoshmarray[$i]}\"/>\n";
      print FILE_OUT "      <dest address=\"${k}\" mem=\"${register}\"/>\n";
      print FILE_OUT "    </map>\n";
    }
  }
  elsif ($line =~ /MAPSHMTOSIM/) {
    for($i = 0; $i < $nshmtosim; $i++) {
      $k = $k + 1;
      print FILE_OUT "    <map direction=\"plctosim\" type=\"analog\">\n";
      print FILE_OUT "      <src address=\"${k}\" mem=\"${register}\"/>\n";
      print FILE_OUT "      <dest address=\"@{shmtosimarray[$i]}\"/>\n";
      print FILE_OUT "    </map>\n";
    }
  }
  elsif ($line =~ /RPC_PLC/) {
    if (($nsimtorpc > 0) || ($nrpctosim > 0)) {
      $line =~ s/RPC_PLC/$emptystring/g;
      print FILE_OUT "$line" or die "Print failed: $!"; 
    }
  }
  elsif ($line =~ /SHM_PLC/) {
    if (($nsimtoshm > 0) || ($nshmtosim > 0)) {
      $line =~ s/SHM_PLC/$emptystring/g;
      print FILE_OUT "$line" or die "Print failed: $!"; 
    }
  }
  else {
    print FILE_OUT "$line" or die "Print failed: $!"; 
  }
}

close(FILE);
close (FILE_OUT);

print("File $outdir/FDServerConfig.xml created\n");


