/*
* Copyright 2013 EUROPEAN UNION
*
* Licenced under the EUPL, Version 1.1 only (the "Licence");
* You may not use this work except in compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* http://ec.europa.eu/idabc/eupl.html
*
* Unless required by applicable law or agreed to in writing, software distributed under the Licence is distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the Licence for the specific language governing permissions and limitations under the Licence.
*/

#include "DynaLoader.h"

DynaLoader::DynaLoader( const std::string& rLibraryName ):
	m_moduleHandle( NULL )
{
	m_sLibraryName = rLibraryName;
}

DynaLoader::~DynaLoader()
{
	if( m_moduleHandle != NULL )
	{
		dlclose( m_moduleHandle );
	}
}

bool DynaLoader::loadModule( void )
{
	if ( NULL != m_moduleHandle ) {
		return true;
	}

	m_moduleHandle = dlopen( m_sLibraryName.c_str(), RTLD_LAZY );

	return ( NULL != m_moduleHandle );
}

void* DynaLoader::getFunction( const std::string& rName )
{
	if( m_moduleHandle != NULL )
	{
		return dlsym( m_moduleHandle, rName.c_str() );
	}
	return NULL;
}
