/*
* Copyright 2013 EUROPEAN UNION
*
* Licenced under the EUPL, Version 1.1 only (the "Licence");
* You may not use this work except in compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* http://ec.europa.eu/idabc/eupl.html
*
* Unless required by applicable law or agreed to in writing, software distributed under the Licence is distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the Licence for the specific language governing permissions and limitations under the Licence.
*/

#if !defined( __DYNALOADER_H__ )
#define __DYNALOADER_H__

#include <string>
#include <stdarg.h>
#include <dlfcn.h>
#define HINSTANCE void*

class DynaLoader
{
public:
	DynaLoader( const std::string& rLibraryName );
	virtual ~DynaLoader();
	bool loadModule( void );
	void* getFunction( const std::string& rName );

private:
	std::string m_sLibraryName;
	HINSTANCE m_moduleHandle;
};

#endif //__DYNALOADER_H__
