/*
 * ctrlLoopsTE.c
 *
 * Real-Time Workshop code generation for Simulink model "ctrlLoopsTE.mdl".
 *
 * Model version              : 1.20
 * Real-Time Workshop version : 7.6  (R2010b)  03-Aug-2010
 * C source code generated on : Sat Oct 18 13:34:44 2014
 *
 * Target selection: grt.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "ctrlLoopsTE.h"
#include "ctrlLoopsTE_private.h"

/* Block signals (auto storage) */
BlockIO_ctrlLoopsTE ctrlLoopsTE_B;

/* Block states (auto storage) */
D_Work_ctrlLoopsTE ctrlLoopsTE_DWork;

/* External inputs (root inport signals with auto storage) */
ExternalInputs_ctrlLoopsTE ctrlLoopsTE_U;

/* External outputs (root outports fed by signals with auto storage) */
ExternalOutputs_ctrlLoopsTE ctrlLoopsTE_Y;

/* Real-time model */
RT_MODEL_ctrlLoopsTE ctrlLoopsTE_M_;
RT_MODEL_ctrlLoopsTE *ctrlLoopsTE_M = &ctrlLoopsTE_M_;
static void rate_scheduler(void);

/*
 * This function updates active task flag for each subrate.
 * The function must be called at model base rate, hence the
 * generated code self-manages all its subrates.
 */
static void rate_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (ctrlLoopsTE_M->Timing.TaskCounters.TID[2])++;
  if ((ctrlLoopsTE_M->Timing.TaskCounters.TID[2]) > 199) {/* Sample time: [0.1s, 0.0s] */
    ctrlLoopsTE_M->Timing.TaskCounters.TID[2] = 0;
  }

  ctrlLoopsTE_M->Timing.sampleHits[2] = (ctrlLoopsTE_M->Timing.TaskCounters.TID
    [2] == 0);
}

/* Model output function */
static void ctrlLoopsTE_output(int_T tid)
{
  real_T rtb_UnitDelay;
  real_T rtb_UnitDelay_k;
  real_T deltaT;
  real_T riseValLimit;
  real_T rateLimiterRate;
  real_T rtb_UnitDelay_cj;
  real_T rtb_P3;
  real_T rtb_Sum1_a;
  real_T rtb_Gain_gy;

  /* UnitDelay: '<S27>/Unit Delay' */
  rtb_UnitDelay = ctrlLoopsTE_DWork.UnitDelay_DSTATE;

  /* Outport: '<Root>/Out1' */
  ctrlLoopsTE_Y.Out1 = ctrlLoopsTE_DWork.UnitDelay_DSTATE;

  /* UnitDelay: '<S29>/Unit Delay' */
  rtb_UnitDelay_k = ctrlLoopsTE_DWork.UnitDelay_DSTATE_j;

  /* Outport: '<Root>/Out2' */
  ctrlLoopsTE_Y.Out2 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_j;

  /* RateLimiter: '<Root>/Rate Limiter1' incorporates:
   *  Constant: '<Root>/xmv12'
   */
  if (ctrlLoopsTE_DWork.LastMajorTime == (rtInf)) {
    ctrlLoopsTE_B.RateLimiter1 = ctrlLoopsTE_P.xmv12_Value;
  } else {
    deltaT = ctrlLoopsTE_M->Timing.t[0] - ctrlLoopsTE_DWork.LastMajorTime;
    riseValLimit = deltaT * ctrlLoopsTE_P.RateLimiter1_RisingLim;
    rateLimiterRate = ctrlLoopsTE_P.xmv12_Value - ctrlLoopsTE_DWork.PrevY;
    if (rateLimiterRate > riseValLimit) {
      ctrlLoopsTE_B.RateLimiter1 = ctrlLoopsTE_DWork.PrevY + riseValLimit;
    } else {
      deltaT *= ctrlLoopsTE_P.RateLimiter1_FallingLim;
      if (rateLimiterRate < deltaT) {
        ctrlLoopsTE_B.RateLimiter1 = ctrlLoopsTE_DWork.PrevY + deltaT;
      } else {
        ctrlLoopsTE_B.RateLimiter1 = ctrlLoopsTE_P.xmv12_Value;
      }
    }
  }

  /* Sum: '<S22>/Sum' incorporates:
   *  Inport: '<Root>/In16'
   */
  ctrlLoopsTE_B.Sum = ctrlLoopsTE_B.RateLimiter1 - ctrlLoopsTE_U.In16;

  /* ZeroOrderHold: '<S22>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold = ctrlLoopsTE_B.Sum;

  /* UnitDelay: '<S1>/Unit Delay' */
  rtb_UnitDelay_cj = ctrlLoopsTE_DWork.UnitDelay_DSTATE_l;

  /* Saturate: '<S1>/Saturation' incorporates:
   *  Gain: '<S22>/Gain'
   *  Gain: '<S22>/Gain1'
   *  Sum: '<S1>/Sum'
   *  Sum: '<S22>/Sum1'
   *  UnitDelay: '<S22>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain * ctrlLoopsTE_B.ZeroOrderHold +
                   ctrlLoopsTE_B.ZeroOrderHold) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_p) *
    ctrlLoopsTE_P.Gain_Gain + ctrlLoopsTE_DWork.UnitDelay_DSTATE_l;
  ctrlLoopsTE_B.Saturation = riseValLimit >= ctrlLoopsTE_P.Saturation_UpperSat ?
    ctrlLoopsTE_P.Saturation_UpperSat : riseValLimit <=
    ctrlLoopsTE_P.Saturation_LowerSat ? ctrlLoopsTE_P.Saturation_LowerSat :
    riseValLimit;

  /* Polyval: '<S7>/P2' */
  rtb_P3 = (ctrlLoopsTE_P.P2_Coefs[0] * ctrlLoopsTE_B.RateLimiter1 +
            ctrlLoopsTE_P.P2_Coefs[1]) * ctrlLoopsTE_B.RateLimiter1 +
    ctrlLoopsTE_P.P2_Coefs[2];

  /* Gain: '<S7>/Gain1' */
  ctrlLoopsTE_B.Gain1 = ctrlLoopsTE_P.Gain1_Gain_m *
    ctrlLoopsTE_DWork.UnitDelay_DSTATE_l;

  /* RateLimiter: '<Root>/Rate Limiter' incorporates:
   *  Constant: '<Root>/xmv13'
   */
  if (ctrlLoopsTE_DWork.LastMajorTime_i == (rtInf)) {
    ctrlLoopsTE_B.RateLimiter = ctrlLoopsTE_P.xmv13_Value;
  } else {
    deltaT = ctrlLoopsTE_M->Timing.t[0] - ctrlLoopsTE_DWork.LastMajorTime_i;
    riseValLimit = deltaT * ctrlLoopsTE_P.RateLimiter_RisingLim;
    rateLimiterRate = ctrlLoopsTE_P.xmv13_Value - ctrlLoopsTE_DWork.PrevY_f;
    if (rateLimiterRate > riseValLimit) {
      ctrlLoopsTE_B.RateLimiter = ctrlLoopsTE_DWork.PrevY_f + riseValLimit;
    } else {
      deltaT *= ctrlLoopsTE_P.RateLimiter_FallingLim;
      if (rateLimiterRate < deltaT) {
        ctrlLoopsTE_B.RateLimiter = ctrlLoopsTE_DWork.PrevY_f + deltaT;
      } else {
        ctrlLoopsTE_B.RateLimiter = ctrlLoopsTE_P.xmv13_Value;
      }
    }
  }

  /* UnitDelay: '<S8>/Unit Delay' */
  ctrlLoopsTE_B.UnitDelay = ctrlLoopsTE_DWork.UnitDelay_DSTATE_f;

  /* Sum: '<Root>/Sum' incorporates:
   *  Gain: '<Root>/Gain'
   */
  deltaT = ctrlLoopsTE_P.Gain_Gain_p * ctrlLoopsTE_B.RateLimiter +
    ctrlLoopsTE_B.UnitDelay;

  /* Sum: '<S28>/Sum' incorporates:
   *  Inport: '<Root>/In2'
   *  Product: '<S5>/Product'
   *  Product: '<S7>/Product1'
   *  Sum: '<S7>/Sum'
   */
  ctrlLoopsTE_B.Sum_k = (rtb_P3 - ctrlLoopsTE_B.Gain1 / deltaT) * deltaT -
    ctrlLoopsTE_U.In2;

  /* ZeroOrderHold: '<S28>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_p = ctrlLoopsTE_B.Sum_k;

  /* Saturate: '<S27>/Saturation' incorporates:
   *  Gain: '<S28>/Gain'
   *  Gain: '<S28>/Gain1'
   *  Sum: '<S27>/Sum'
   *  Sum: '<S28>/Sum1'
   *  UnitDelay: '<S28>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_i * ctrlLoopsTE_B.ZeroOrderHold_p +
                   ctrlLoopsTE_B.ZeroOrderHold_p) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_g) *
    ctrlLoopsTE_P.Gain_Gain_o + rtb_UnitDelay;
  ctrlLoopsTE_B.Saturation_j = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_m ? ctrlLoopsTE_P.Saturation_UpperSat_m :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_o ?
    ctrlLoopsTE_P.Saturation_LowerSat_o : riseValLimit;

  /* Gain: '<S7>/Gain' */
  ctrlLoopsTE_B.Gain = ctrlLoopsTE_P.Gain_Gain_f * rtb_UnitDelay_cj;

  /* Sum: '<S30>/Sum' incorporates:
   *  Inport: '<Root>/In3'
   *  Polyval: '<S7>/P3'
   *  Product: '<S6>/Product'
   *  Product: '<S7>/Product'
   *  Sum: '<S7>/Sum1'
   */
  ctrlLoopsTE_B.Sum_n = (((ctrlLoopsTE_P.P3_Coefs[0] *
    ctrlLoopsTE_B.RateLimiter1 + ctrlLoopsTE_P.P3_Coefs[1]) *
    ctrlLoopsTE_B.RateLimiter1 + ctrlLoopsTE_P.P3_Coefs[2]) + ctrlLoopsTE_B.Gain
    / deltaT) * deltaT - ctrlLoopsTE_U.In3;

  /* ZeroOrderHold: '<S30>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_o = ctrlLoopsTE_B.Sum_n;

  /* Saturate: '<S29>/Saturation' incorporates:
   *  Gain: '<S30>/Gain'
   *  Gain: '<S30>/Gain1'
   *  Sum: '<S29>/Sum'
   *  Sum: '<S30>/Sum1'
   *  UnitDelay: '<S30>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_o * ctrlLoopsTE_B.ZeroOrderHold_o +
                   ctrlLoopsTE_B.ZeroOrderHold_o) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lw) *
    ctrlLoopsTE_P.Gain_Gain_c + rtb_UnitDelay_k;
  ctrlLoopsTE_B.Saturation_f = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_g ? ctrlLoopsTE_P.Saturation_UpperSat_g :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_e ?
    ctrlLoopsTE_P.Saturation_LowerSat_e : riseValLimit;

  /* Outport: '<Root>/Out3' incorporates:
   *  UnitDelay: '<S23>/Unit Delay'
   */
  ctrlLoopsTE_Y.Out3 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_d;

  /* Outport: '<Root>/Out4' incorporates:
   *  UnitDelay: '<S25>/Unit Delay'
   */
  ctrlLoopsTE_Y.Out4 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_gv;
  if (ctrlLoopsTE_M->Timing.TaskCounters.TID[2] == 0) {
    /* Sum: '<S2>/Sum1' incorporates:
     *  Inport: '<Root>/In14'
     *  Inport: '<Root>/In15'
     */
    rtb_Sum1_a = ctrlLoopsTE_U.In14 + ctrlLoopsTE_U.In15;

    /* Sum: '<S20>/Sum' incorporates:
     *  Constant: '<Root>/xmv6'
     *  Gain: '<S2>/Gain1'
     *  Inport: '<Root>/In14'
     *  Product: '<S2>/Product1'
     */
    ctrlLoopsTE_B.Sum_b = ctrlLoopsTE_P.xmv6_Value - ctrlLoopsTE_P.Gain1_Gain_d *
      ctrlLoopsTE_U.In14 / rtb_Sum1_a;

    /* Gain: '<S20>/Gain' incorporates:
     *  Gain: '<S20>/Gain1'
     *  Sum: '<S20>/Sum1'
     *  UnitDelay: '<S20>/Unit Delay'
     */
    rtb_Gain_gy = ((ctrlLoopsTE_P.Gain1_Gain_h * ctrlLoopsTE_B.Sum_b +
                    ctrlLoopsTE_B.Sum_b) - ctrlLoopsTE_DWork.UnitDelay_DSTATE_c)
      * ctrlLoopsTE_P.Gain_Gain_a;

    /* Sum: '<S10>/Sum2' incorporates:
     *  UnitDelay: '<S10>/Unit Delay'
     */
    ctrlLoopsTE_B.Sum2 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_h + rtb_Gain_gy;
  }

  /* Sum: '<S24>/Sum' incorporates:
   *  Inport: '<Root>/In1'
   *  Product: '<S3>/Product'
   */
  ctrlLoopsTE_B.Sum_e = ctrlLoopsTE_B.Sum2 * deltaT - ctrlLoopsTE_U.In1;

  /* ZeroOrderHold: '<S24>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_e = ctrlLoopsTE_B.Sum_e;

  /* Saturate: '<S23>/Saturation' incorporates:
   *  Gain: '<S24>/Gain'
   *  Gain: '<S24>/Gain1'
   *  Sum: '<S23>/Sum'
   *  Sum: '<S24>/Sum1'
   *  UnitDelay: '<S23>/Unit Delay'
   *  UnitDelay: '<S24>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_k * ctrlLoopsTE_B.ZeroOrderHold_e +
                   ctrlLoopsTE_B.ZeroOrderHold_e) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_o) *
    ctrlLoopsTE_P.Gain_Gain_oo + ctrlLoopsTE_DWork.UnitDelay_DSTATE_d;
  ctrlLoopsTE_B.Saturation_o = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_k ? ctrlLoopsTE_P.Saturation_UpperSat_k :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_c ?
    ctrlLoopsTE_P.Saturation_LowerSat_c : riseValLimit;
  if (ctrlLoopsTE_M->Timing.TaskCounters.TID[2] == 0) {
    /* Sum: '<S21>/Sum' incorporates:
     *  Constant: '<Root>/xmv7'
     */
    ctrlLoopsTE_B.Sum_ng = ctrlLoopsTE_P.xmv7_Value - rtb_Sum1_a;

    /* Sum: '<S10>/Sum1' incorporates:
     *  Gain: '<S21>/Gain'
     *  Gain: '<S21>/Gain1'
     *  Sum: '<S21>/Sum1'
     *  UnitDelay: '<S10>/Unit Delay1'
     *  UnitDelay: '<S21>/Unit Delay'
     */
    ctrlLoopsTE_B.Sum1 = (((ctrlLoopsTE_P.Gain1_Gain_e * ctrlLoopsTE_B.Sum_ng +
      ctrlLoopsTE_B.Sum_ng) - ctrlLoopsTE_DWork.UnitDelay_DSTATE_pq) *
                          ctrlLoopsTE_P.Gain_Gain_a2 - rtb_Gain_gy) +
      ctrlLoopsTE_DWork.UnitDelay1_DSTATE;
  }

  /* Sum: '<S26>/Sum' incorporates:
   *  Inport: '<Root>/In4'
   *  Product: '<S4>/Product'
   */
  ctrlLoopsTE_B.Sum_b4 = ctrlLoopsTE_B.Sum1 * deltaT - ctrlLoopsTE_U.In4;

  /* ZeroOrderHold: '<S26>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_h = ctrlLoopsTE_B.Sum_b4;

  /* Saturate: '<S25>/Saturation' incorporates:
   *  Gain: '<S26>/Gain'
   *  Gain: '<S26>/Gain1'
   *  Sum: '<S25>/Sum'
   *  Sum: '<S26>/Sum1'
   *  UnitDelay: '<S25>/Unit Delay'
   *  UnitDelay: '<S26>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_hs * ctrlLoopsTE_B.ZeroOrderHold_h +
                   ctrlLoopsTE_B.ZeroOrderHold_h) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ls) *
    ctrlLoopsTE_P.Gain_Gain_a0 + ctrlLoopsTE_DWork.UnitDelay_DSTATE_gv;
  ctrlLoopsTE_B.Saturation_b = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_ml ? ctrlLoopsTE_P.Saturation_UpperSat_ml :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_d ?
    ctrlLoopsTE_P.Saturation_LowerSat_d : riseValLimit;

  /* Outport: '<Root>/Out5' incorporates:
   *  Constant: '<Root>/xmv9'
   *  Constant: '<S14>/Max Allowed'
   *  Gain: '<S14>/Gain'
   *  Saturate: '<S14>/Saturation'
   *  Saturate: '<S14>/Saturation1'
   *  Sum: '<S14>/Sum'
   *  Sum: '<S14>/Sum1'
   *  UnitDelay: '<S17>/Unit Delay'
   */
  riseValLimit = (ctrlLoopsTE_DWork.UnitDelay_DSTATE_n -
                  ctrlLoopsTE_P.MaxAllowed_Value) * ctrlLoopsTE_P.Gain_Gain_k;
  riseValLimit = (riseValLimit >= ctrlLoopsTE_P.Saturation1_UpperSat ?
                  ctrlLoopsTE_P.Saturation1_UpperSat : riseValLimit <=
                  ctrlLoopsTE_P.Saturation1_LowerSat ?
                  ctrlLoopsTE_P.Saturation1_LowerSat : riseValLimit) +
    ctrlLoopsTE_P.xmv9_Value;
  ctrlLoopsTE_Y.Out5 = riseValLimit >= ctrlLoopsTE_P.Saturation_UpperSat_o ?
    ctrlLoopsTE_P.Saturation_UpperSat_o : riseValLimit <=
    ctrlLoopsTE_P.Saturation_LowerSat_b ? ctrlLoopsTE_P.Saturation_LowerSat_b :
    riseValLimit;

  /* Outport: '<Root>/Out11' incorporates:
   *  UnitDelay: '<S17>/Unit Delay'
   */
  ctrlLoopsTE_Y.Out11 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_n;

  /* Sum: '<S34>/Sum' incorporates:
   *  Constant: '<Root>/xmv3'
   *  Inport: '<Root>/In6'
   */
  ctrlLoopsTE_B.Sum_ne = ctrlLoopsTE_P.xmv3_Value - ctrlLoopsTE_U.In6;

  /* Saturate: '<S11>/Saturation' incorporates:
   *  Gain: '<S34>/Gain'
   *  Gain: '<S34>/Gain1'
   *  Sum: '<S11>/Sum'
   *  Sum: '<S34>/Sum1'
   *  UnitDelay: '<S11>/Unit Delay'
   *  UnitDelay: '<S34>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_g * ctrlLoopsTE_B.Sum_ne +
                   ctrlLoopsTE_B.Sum_ne) - ctrlLoopsTE_DWork.UnitDelay_DSTATE_pz)
    * ctrlLoopsTE_P.Gain_Gain_e + ctrlLoopsTE_DWork.UnitDelay_DSTATE_k;
  ctrlLoopsTE_B.Saturation_bq = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_a ? ctrlLoopsTE_P.Saturation_UpperSat_a :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_d0 ?
    ctrlLoopsTE_P.Saturation_LowerSat_d0 : riseValLimit;

  /* Sum: '<S40>/Sum' incorporates:
   *  Inport: '<Root>/In9'
   *  UnitDelay: '<S11>/Unit Delay'
   */
  ctrlLoopsTE_B.Sum_km = ctrlLoopsTE_DWork.UnitDelay_DSTATE_k -
    ctrlLoopsTE_U.In9;

  /* Saturate: '<S17>/Saturation' incorporates:
   *  Gain: '<S40>/Gain'
   *  Gain: '<S40>/Gain1'
   *  Sum: '<S17>/Sum'
   *  Sum: '<S40>/Sum1'
   *  UnitDelay: '<S17>/Unit Delay'
   *  UnitDelay: '<S40>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_gc * ctrlLoopsTE_B.Sum_km +
                   ctrlLoopsTE_B.Sum_km) - ctrlLoopsTE_DWork.UnitDelay_DSTATE_e)
    * ctrlLoopsTE_P.Gain_Gain_j + ctrlLoopsTE_DWork.UnitDelay_DSTATE_n;
  ctrlLoopsTE_B.Saturation_o0 = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_c ? ctrlLoopsTE_P.Saturation_UpperSat_c :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_h ?
    ctrlLoopsTE_P.Saturation_LowerSat_h : riseValLimit;

  /* Outport: '<Root>/Out6' incorporates:
   *  UnitDelay: '<S32>/Unit Delay'
   */
  ctrlLoopsTE_Y.Out6 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_b;

  /* UnitDelay: '<S12>/Unit Delay' */
  ctrlLoopsTE_B.UnitDelay_g = ctrlLoopsTE_DWork.UnitDelay_DSTATE_py;

  /* Sum: '<S33>/Sum' incorporates:
   *  Inport: '<Root>/In8'
   *  Product: '<S9>/Product'
   */
  ctrlLoopsTE_B.Sum_ep = ctrlLoopsTE_B.UnitDelay_g * deltaT - ctrlLoopsTE_U.In8;

  /* ZeroOrderHold: '<S33>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_hk = ctrlLoopsTE_B.Sum_ep;

  /* Saturate: '<S32>/Saturation' incorporates:
   *  Gain: '<S33>/Gain'
   *  Gain: '<S33>/Gain1'
   *  Sum: '<S32>/Sum'
   *  Sum: '<S33>/Sum1'
   *  UnitDelay: '<S32>/Unit Delay'
   *  UnitDelay: '<S33>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_l * ctrlLoopsTE_B.ZeroOrderHold_hk +
                   ctrlLoopsTE_B.ZeroOrderHold_hk) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_li) *
    ctrlLoopsTE_P.Gain_Gain_i + ctrlLoopsTE_DWork.UnitDelay_DSTATE_b;
  ctrlLoopsTE_B.Saturation_i = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_b ? ctrlLoopsTE_P.Saturation_UpperSat_b :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_eh ?
    ctrlLoopsTE_P.Saturation_LowerSat_eh : riseValLimit;

  /* Sum: '<S35>/Sum' incorporates:
   *  Constant: '<Root>/xmv4'
   *  Inport: '<Root>/In5'
   */
  ctrlLoopsTE_B.Sum_o = ctrlLoopsTE_P.xmv4_Value - ctrlLoopsTE_U.In5;

  /* Saturate: '<S12>/Saturation' incorporates:
   *  Gain: '<S35>/Gain'
   *  Gain: '<S35>/Gain1'
   *  Sum: '<S12>/Sum'
   *  Sum: '<S35>/Sum1'
   *  UnitDelay: '<S35>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_d1 * ctrlLoopsTE_B.Sum_o +
                   ctrlLoopsTE_B.Sum_o) - ctrlLoopsTE_DWork.UnitDelay_DSTATE_j3)
    * ctrlLoopsTE_P.Gain_Gain_fx + ctrlLoopsTE_B.UnitDelay_g;
  ctrlLoopsTE_B.Saturation_m = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_a1 ? ctrlLoopsTE_P.Saturation_UpperSat_a1 :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_m ?
    ctrlLoopsTE_P.Saturation_LowerSat_m : riseValLimit;

  /* Outport: '<Root>/Out7' incorporates:
   *  UnitDelay: '<S37>/Unit Delay'
   */
  ctrlLoopsTE_Y.Out7 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_ff;

  /* UnitDelay: '<S16>/Unit Delay' */
  ctrlLoopsTE_B.UnitDelay_c = ctrlLoopsTE_DWork.UnitDelay_DSTATE_hy;

  /* Sum: '<S38>/Sum' incorporates:
   *  Inport: '<Root>/In11'
   *  Product: '<S15>/Product'
   */
  ctrlLoopsTE_B.Sum_a = ctrlLoopsTE_B.UnitDelay_c * deltaT - ctrlLoopsTE_U.In11;

  /* ZeroOrderHold: '<S38>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_d = ctrlLoopsTE_B.Sum_a;

  /* Saturate: '<S37>/Saturation' incorporates:
   *  Gain: '<S38>/Gain'
   *  Gain: '<S38>/Gain1'
   *  Sum: '<S37>/Sum'
   *  Sum: '<S38>/Sum1'
   *  UnitDelay: '<S37>/Unit Delay'
   *  UnitDelay: '<S38>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_n * ctrlLoopsTE_B.ZeroOrderHold_d +
                   ctrlLoopsTE_B.ZeroOrderHold_d) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lm) *
    ctrlLoopsTE_P.Gain_Gain_ft + ctrlLoopsTE_DWork.UnitDelay_DSTATE_ff;
  ctrlLoopsTE_B.Saturation_n = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_aq ? ctrlLoopsTE_P.Saturation_UpperSat_aq :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_m5 ?
    ctrlLoopsTE_P.Saturation_LowerSat_m5 : riseValLimit;

  /* Sum: '<S39>/Sum' incorporates:
   *  Constant: '<Root>/xmv2'
   *  Inport: '<Root>/In10'
   */
  ctrlLoopsTE_B.Sum_c = ctrlLoopsTE_P.xmv2_Value - ctrlLoopsTE_U.In10;

  /* Saturate: '<S16>/Saturation' incorporates:
   *  Gain: '<S39>/Gain'
   *  Gain: '<S39>/Gain1'
   *  Sum: '<S16>/Sum'
   *  Sum: '<S39>/Sum1'
   *  UnitDelay: '<S39>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_j * ctrlLoopsTE_B.Sum_c +
                   ctrlLoopsTE_B.Sum_c) - ctrlLoopsTE_DWork.UnitDelay_DSTATE_ef)
    * ctrlLoopsTE_P.Gain_Gain_b + ctrlLoopsTE_B.UnitDelay_c;
  ctrlLoopsTE_B.Saturation_g = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_gb ? ctrlLoopsTE_P.Saturation_UpperSat_gb :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_a ?
    ctrlLoopsTE_P.Saturation_LowerSat_a : riseValLimit;

  /* Outport: '<Root>/Out8' incorporates:
   *  UnitDelay: '<S41>/Unit Delay'
   */
  ctrlLoopsTE_Y.Out8 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_lr;

  /* Sum: '<S31>/Sum' incorporates:
   *  Inport: '<Root>/In13'
   */
  ctrlLoopsTE_B.Sum_p = ctrlLoopsTE_B.RateLimiter - ctrlLoopsTE_U.In13;

  /* ZeroOrderHold: '<S31>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_eg = ctrlLoopsTE_B.Sum_p;

  /* Saturate: '<S8>/Saturation' incorporates:
   *  Gain: '<S31>/Gain'
   *  Gain: '<S31>/Gain1'
   *  Sum: '<S31>/Sum1'
   *  Sum: '<S8>/Sum'
   *  UnitDelay: '<S31>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_b * ctrlLoopsTE_B.ZeroOrderHold_eg +
                   ctrlLoopsTE_B.ZeroOrderHold_eg) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_bm) *
    ctrlLoopsTE_P.Gain_Gain_pu + ctrlLoopsTE_B.UnitDelay;
  ctrlLoopsTE_B.Saturation_h = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_c3 ? ctrlLoopsTE_P.Saturation_UpperSat_c3 :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_ax ?
    ctrlLoopsTE_P.Saturation_LowerSat_ax : riseValLimit;

  /* UnitDelay: '<S19>/Unit Delay' */
  ctrlLoopsTE_B.UnitDelay_n = ctrlLoopsTE_DWork.UnitDelay_DSTATE_i;

  /* Sum: '<S42>/Sum' incorporates:
   *  Inport: '<Root>/In13'
   *  Product: '<S18>/Product'
   */
  ctrlLoopsTE_B.Sum_kmo = ctrlLoopsTE_B.UnitDelay_n * deltaT -
    ctrlLoopsTE_U.In13;

  /* ZeroOrderHold: '<S42>/Zero-Order Hold' */
  ctrlLoopsTE_B.ZeroOrderHold_hz = ctrlLoopsTE_B.Sum_kmo;

  /* Saturate: '<S41>/Saturation' incorporates:
   *  Gain: '<S42>/Gain'
   *  Gain: '<S42>/Gain1'
   *  Sum: '<S41>/Sum'
   *  Sum: '<S42>/Sum1'
   *  UnitDelay: '<S41>/Unit Delay'
   *  UnitDelay: '<S42>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_d0 * ctrlLoopsTE_B.ZeroOrderHold_hz
                   + ctrlLoopsTE_B.ZeroOrderHold_hz) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f0) *
    ctrlLoopsTE_P.Gain_Gain_cv + ctrlLoopsTE_DWork.UnitDelay_DSTATE_lr;
  ctrlLoopsTE_B.Saturation_gf = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_d ? ctrlLoopsTE_P.Saturation_UpperSat_d :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_i ?
    ctrlLoopsTE_P.Saturation_LowerSat_i : riseValLimit;

  /* Sum: '<S43>/Sum' incorporates:
   *  Constant: '<Root>/xmv1'
   *  Inport: '<Root>/In12'
   */
  ctrlLoopsTE_B.Sum_pa = ctrlLoopsTE_P.xmv1_Value - ctrlLoopsTE_U.In12;

  /* Saturate: '<S19>/Saturation' incorporates:
   *  Gain: '<S43>/Gain'
   *  Gain: '<S43>/Gain1'
   *  Sum: '<S19>/Sum'
   *  Sum: '<S43>/Sum1'
   *  UnitDelay: '<S43>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_a * ctrlLoopsTE_B.Sum_pa +
                   ctrlLoopsTE_B.Sum_pa) -
                  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lis) *
    ctrlLoopsTE_P.Gain_Gain_cl + ctrlLoopsTE_B.UnitDelay_n;
  ctrlLoopsTE_B.Saturation_c = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_cq ? ctrlLoopsTE_P.Saturation_UpperSat_cq :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_n ?
    ctrlLoopsTE_P.Saturation_LowerSat_n : riseValLimit;

  /* Outport: '<Root>/Out9' incorporates:
   *  Constant: '<Root>/xmv10'
   */
  ctrlLoopsTE_Y.Out9 = ctrlLoopsTE_P.xmv10_Value;

  /* Outport: '<Root>/Out10' incorporates:
   *  UnitDelay: '<S13>/Unit Delay'
   */
  ctrlLoopsTE_Y.Out10 = ctrlLoopsTE_DWork.UnitDelay_DSTATE_ch;

  /* Sum: '<S36>/Sum' incorporates:
   *  Constant: '<Root>/xmv8'
   *  Inport: '<Root>/In7'
   */
  ctrlLoopsTE_B.Sum_h = ctrlLoopsTE_P.xmv8_Value - ctrlLoopsTE_U.In7;

  /* Saturate: '<S13>/Saturation' incorporates:
   *  Gain: '<S36>/Gain'
   *  Gain: '<S36>/Gain1'
   *  Sum: '<S13>/Sum'
   *  Sum: '<S36>/Sum1'
   *  UnitDelay: '<S13>/Unit Delay'
   *  UnitDelay: '<S36>/Unit Delay'
   */
  riseValLimit = ((ctrlLoopsTE_P.Gain1_Gain_at * ctrlLoopsTE_B.Sum_h +
                   ctrlLoopsTE_B.Sum_h) - ctrlLoopsTE_DWork.UnitDelay_DSTATE_m) *
    ctrlLoopsTE_P.Gain_Gain_fl + ctrlLoopsTE_DWork.UnitDelay_DSTATE_ch;
  ctrlLoopsTE_B.Saturation_oj = riseValLimit >=
    ctrlLoopsTE_P.Saturation_UpperSat_n ? ctrlLoopsTE_P.Saturation_UpperSat_n :
    riseValLimit <= ctrlLoopsTE_P.Saturation_LowerSat_hv ?
    ctrlLoopsTE_P.Saturation_LowerSat_hv : riseValLimit;

  /* Outport: '<Root>/Out12' incorporates:
   *  Constant: '<Root>/xmv11'
   */
  ctrlLoopsTE_Y.Out12 = ctrlLoopsTE_P.xmv11_Value;

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model update function */
static void ctrlLoopsTE_update(int_T tid)
{
  /* Update for UnitDelay: '<S27>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE = ctrlLoopsTE_B.Saturation_j;

  /* Update for UnitDelay: '<S29>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j = ctrlLoopsTE_B.Saturation_f;

  /* Update for RateLimiter: '<Root>/Rate Limiter1' */
  ctrlLoopsTE_DWork.PrevY = ctrlLoopsTE_B.RateLimiter1;
  ctrlLoopsTE_DWork.LastMajorTime = ctrlLoopsTE_M->Timing.t[0];

  /* Update for UnitDelay: '<S22>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_p = ctrlLoopsTE_B.ZeroOrderHold;

  /* Update for UnitDelay: '<S1>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_l = ctrlLoopsTE_B.Saturation;

  /* Update for RateLimiter: '<Root>/Rate Limiter' */
  ctrlLoopsTE_DWork.PrevY_f = ctrlLoopsTE_B.RateLimiter;
  ctrlLoopsTE_DWork.LastMajorTime_i = ctrlLoopsTE_M->Timing.t[0];

  /* Update for UnitDelay: '<S8>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f = ctrlLoopsTE_B.Saturation_h;

  /* Update for UnitDelay: '<S28>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_g = ctrlLoopsTE_B.ZeroOrderHold_p;

  /* Update for UnitDelay: '<S30>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lw = ctrlLoopsTE_B.ZeroOrderHold_o;

  /* Update for UnitDelay: '<S23>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_d = ctrlLoopsTE_B.Saturation_o;

  /* Update for UnitDelay: '<S25>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_gv = ctrlLoopsTE_B.Saturation_b;
  if (ctrlLoopsTE_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update for UnitDelay: '<S10>/Unit Delay' */
    ctrlLoopsTE_DWork.UnitDelay_DSTATE_h = ctrlLoopsTE_B.Sum2;

    /* Update for UnitDelay: '<S20>/Unit Delay' */
    ctrlLoopsTE_DWork.UnitDelay_DSTATE_c = ctrlLoopsTE_B.Sum_b;
  }

  /* Update for UnitDelay: '<S24>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_o = ctrlLoopsTE_B.ZeroOrderHold_e;
  if (ctrlLoopsTE_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update for UnitDelay: '<S21>/Unit Delay' */
    ctrlLoopsTE_DWork.UnitDelay_DSTATE_pq = ctrlLoopsTE_B.Sum_ng;

    /* Update for UnitDelay: '<S10>/Unit Delay1' */
    ctrlLoopsTE_DWork.UnitDelay1_DSTATE = ctrlLoopsTE_B.Sum1;
  }

  /* Update for UnitDelay: '<S26>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ls = ctrlLoopsTE_B.ZeroOrderHold_h;

  /* Update for UnitDelay: '<S17>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_n = ctrlLoopsTE_B.Saturation_o0;

  /* Update for UnitDelay: '<S34>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_pz = ctrlLoopsTE_B.Sum_ne;

  /* Update for UnitDelay: '<S11>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_k = ctrlLoopsTE_B.Saturation_bq;

  /* Update for UnitDelay: '<S40>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_e = ctrlLoopsTE_B.Sum_km;

  /* Update for UnitDelay: '<S32>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_b = ctrlLoopsTE_B.Saturation_i;

  /* Update for UnitDelay: '<S12>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_py = ctrlLoopsTE_B.Saturation_m;

  /* Update for UnitDelay: '<S33>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_li = ctrlLoopsTE_B.ZeroOrderHold_hk;

  /* Update for UnitDelay: '<S35>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j3 = ctrlLoopsTE_B.Sum_o;

  /* Update for UnitDelay: '<S37>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ff = ctrlLoopsTE_B.Saturation_n;

  /* Update for UnitDelay: '<S16>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_hy = ctrlLoopsTE_B.Saturation_g;

  /* Update for UnitDelay: '<S38>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lm = ctrlLoopsTE_B.ZeroOrderHold_d;

  /* Update for UnitDelay: '<S39>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ef = ctrlLoopsTE_B.Sum_c;

  /* Update for UnitDelay: '<S41>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lr = ctrlLoopsTE_B.Saturation_gf;

  /* Update for UnitDelay: '<S31>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_bm = ctrlLoopsTE_B.ZeroOrderHold_eg;

  /* Update for UnitDelay: '<S19>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_i = ctrlLoopsTE_B.Saturation_c;

  /* Update for UnitDelay: '<S42>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f0 = ctrlLoopsTE_B.ZeroOrderHold_hz;

  /* Update for UnitDelay: '<S43>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lis = ctrlLoopsTE_B.Sum_pa;

  /* Update for UnitDelay: '<S13>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ch = ctrlLoopsTE_B.Saturation_oj;

  /* Update for UnitDelay: '<S36>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_m = ctrlLoopsTE_B.Sum_h;

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++ctrlLoopsTE_M->Timing.clockTick0)) {
    ++ctrlLoopsTE_M->Timing.clockTickH0;
  }

  ctrlLoopsTE_M->Timing.t[0] = ctrlLoopsTE_M->Timing.clockTick0 *
    ctrlLoopsTE_M->Timing.stepSize0 + ctrlLoopsTE_M->Timing.clockTickH0 *
    ctrlLoopsTE_M->Timing.stepSize0 * 4294967296.0;

  {
    /* Update absolute timer for sample time: [0.0005s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick1"
     * and "Timing.stepSize1". Size of "clockTick1" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++ctrlLoopsTE_M->Timing.clockTick1)) {
      ++ctrlLoopsTE_M->Timing.clockTickH1;
    }

    ctrlLoopsTE_M->Timing.t[1] = ctrlLoopsTE_M->Timing.clockTick1 *
      ctrlLoopsTE_M->Timing.stepSize1 + ctrlLoopsTE_M->Timing.clockTickH1 *
      ctrlLoopsTE_M->Timing.stepSize1 * 4294967296.0;
  }

  if (ctrlLoopsTE_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update absolute timer for sample time: [0.1s, 0.0s] */
    /* The "clockTick2" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick2"
     * and "Timing.stepSize2". Size of "clockTick2" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick2 and the high bits
     * Timing.clockTickH2. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++ctrlLoopsTE_M->Timing.clockTick2)) {
      ++ctrlLoopsTE_M->Timing.clockTickH2;
    }

    ctrlLoopsTE_M->Timing.t[2] = ctrlLoopsTE_M->Timing.clockTick2 *
      ctrlLoopsTE_M->Timing.stepSize2 + ctrlLoopsTE_M->Timing.clockTickH2 *
      ctrlLoopsTE_M->Timing.stepSize2 * 4294967296.0;
  }

  rate_scheduler();

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model initialize function */
void ctrlLoopsTE_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* non-finite (run-time) assignments */
  ctrlLoopsTE_P.Saturation_UpperSat = rtInf;
  ctrlLoopsTE_P.Saturation_LowerSat = rtMinusInf;
  ctrlLoopsTE_P.Saturation1_LowerSat = rtMinusInf;

  /* initialize real-time model */
  (void) memset((void *)ctrlLoopsTE_M, 0,
                sizeof(RT_MODEL_ctrlLoopsTE));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&ctrlLoopsTE_M->solverInfo,
                          &ctrlLoopsTE_M->Timing.simTimeStep);
    rtsiSetTPtr(&ctrlLoopsTE_M->solverInfo, &rtmGetTPtr(ctrlLoopsTE_M));
    rtsiSetStepSizePtr(&ctrlLoopsTE_M->solverInfo,
                       &ctrlLoopsTE_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&ctrlLoopsTE_M->solverInfo, (&rtmGetErrorStatus
      (ctrlLoopsTE_M)));
    rtsiSetRTModelPtr(&ctrlLoopsTE_M->solverInfo, ctrlLoopsTE_M);
  }

  rtsiSetSimTimeStep(&ctrlLoopsTE_M->solverInfo, MAJOR_TIME_STEP);
  rtsiSetSolverName(&ctrlLoopsTE_M->solverInfo,"FixedStepDiscrete");

  /* Initialize timing info */
  {
    int_T *mdlTsMap = ctrlLoopsTE_M->Timing.sampleTimeTaskIDArray;
    mdlTsMap[0] = 0;
    mdlTsMap[1] = 1;
    mdlTsMap[2] = 2;
    ctrlLoopsTE_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    ctrlLoopsTE_M->Timing.sampleTimes = (&ctrlLoopsTE_M->
      Timing.sampleTimesArray[0]);
    ctrlLoopsTE_M->Timing.offsetTimes = (&ctrlLoopsTE_M->
      Timing.offsetTimesArray[0]);

    /* task periods */
    ctrlLoopsTE_M->Timing.sampleTimes[0] = (0.0);
    ctrlLoopsTE_M->Timing.sampleTimes[1] = (0.0005);
    ctrlLoopsTE_M->Timing.sampleTimes[2] = (0.1);

    /* task offsets */
    ctrlLoopsTE_M->Timing.offsetTimes[0] = (0.0);
    ctrlLoopsTE_M->Timing.offsetTimes[1] = (0.0);
    ctrlLoopsTE_M->Timing.offsetTimes[2] = (0.0);
  }

  rtmSetTPtr(ctrlLoopsTE_M, &ctrlLoopsTE_M->Timing.tArray[0]);

  {
    int_T *mdlSampleHits = ctrlLoopsTE_M->Timing.sampleHitArray;
    mdlSampleHits[0] = 1;
    mdlSampleHits[1] = 1;
    mdlSampleHits[2] = 1;
    ctrlLoopsTE_M->Timing.sampleHits = (&mdlSampleHits[0]);
  }

  rtmSetTFinal(ctrlLoopsTE_M, -1);
  ctrlLoopsTE_M->Timing.stepSize0 = 0.0005;
  ctrlLoopsTE_M->Timing.stepSize1 = 0.0005;
  ctrlLoopsTE_M->Timing.stepSize2 = 0.1;
  ctrlLoopsTE_M->solverInfoPtr = (&ctrlLoopsTE_M->solverInfo);
  ctrlLoopsTE_M->Timing.stepSize = (0.0005);
  rtsiSetFixedStepSize(&ctrlLoopsTE_M->solverInfo, 0.0005);
  rtsiSetSolverMode(&ctrlLoopsTE_M->solverInfo, SOLVER_MODE_SINGLETASKING);

  /* block I/O */
  ctrlLoopsTE_M->ModelData.blockIO = ((void *) &ctrlLoopsTE_B);
  (void) memset(((void *) &ctrlLoopsTE_B), 0,
                sizeof(BlockIO_ctrlLoopsTE));

  /* parameters */
  ctrlLoopsTE_M->ModelData.defaultParam = ((real_T *)&ctrlLoopsTE_P);

  /* states (dwork) */
  ctrlLoopsTE_M->Work.dwork = ((void *) &ctrlLoopsTE_DWork);
  (void) memset((void *)&ctrlLoopsTE_DWork, 0,
                sizeof(D_Work_ctrlLoopsTE));

  /* external inputs */
  ctrlLoopsTE_M->ModelData.inputs = (((void*)&ctrlLoopsTE_U));
  (void) memset((void *)&ctrlLoopsTE_U, 0,
                sizeof(ExternalInputs_ctrlLoopsTE));

  /* external outputs */
  ctrlLoopsTE_M->ModelData.outputs = (&ctrlLoopsTE_Y);
  (void) memset((void *)&ctrlLoopsTE_Y, 0,
                sizeof(ExternalOutputs_ctrlLoopsTE));

  /* initial state override */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE = 88.9535885629885;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j = 8.6213126537678111;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_p = -0.90293084038273719;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_l = 0.44930289407604906;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f = -0.15662337329503184;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_g = 1.7155822874910882;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lw = 17.305402107687655;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_d = 19.331317960230145;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_gv = 51.257455154567779;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_h = 0.0025592877959398157;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_c = 0.23548206041270703;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_o = 0.0031117404628384637;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_pq = -0.514449999441716;
  ctrlLoopsTE_DWork.UnitDelay1_DSTATE = 0.099817696241459225;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ls = 0.021429200692442585;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_n = 90.66499236205189;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_pz = -1.2969146280120327;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_k = 82.459452277163024;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_e = -0.54942020685508908;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_b = 8.7569192962169069;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_py = 0.00088298897521340246;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_li = -0.0066772276167958861;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j3 = 1.8860923290681058;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ff = 29.16474681788733;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_hy = 0.22333678194461642;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lm = -0.044397406592729283;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ef = 0.86854090566563258;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lr = 39.450610301132237;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_bm = 0.11034077103533591;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_i = 0.23009997429756654;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f0 = 0.081115254679140492;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lis = 1.4502848920858042;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ch = 35.55180700573311;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_m = -0.0025293811206239525;
}

/* Model terminate function */
void ctrlLoopsTE_terminate(void)
{
  /* (no terminate code required) */
}

/*========================================================================*
 * Start of GRT compatible call interface                                 *
 *========================================================================*/
void MdlOutputs(int_T tid)
{
  ctrlLoopsTE_output(tid);
}

void MdlUpdate(int_T tid)
{
  ctrlLoopsTE_update(tid);
}

void MdlInitializeSizes(void)
{
  ctrlLoopsTE_M->Sizes.numContStates = (0);/* Number of continuous states */
  ctrlLoopsTE_M->Sizes.numY = (12);    /* Number of model outputs */
  ctrlLoopsTE_M->Sizes.numU = (16);    /* Number of model inputs */
  ctrlLoopsTE_M->Sizes.sysDirFeedThru = (1);/* The model is direct feedthrough */
  ctrlLoopsTE_M->Sizes.numSampTimes = (3);/* Number of sample times */
  ctrlLoopsTE_M->Sizes.numBlocks = (195);/* Number of blocks */
  ctrlLoopsTE_M->Sizes.numBlockIO = (51);/* Number of block outputs */
  ctrlLoopsTE_M->Sizes.numBlockPrms = (130);/* Sum of parameter "widths" */
}

void MdlInitializeSampleTimes(void)
{
}

void MdlInitialize(void)
{
  /* InitializeConditions for UnitDelay: '<S27>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE = ctrlLoopsTE_P.UnitDelay_X0;

  /* InitializeConditions for UnitDelay: '<S29>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j = ctrlLoopsTE_P.UnitDelay_X0_a;

  /* InitializeConditions for RateLimiter: '<Root>/Rate Limiter1' */
  ctrlLoopsTE_DWork.LastMajorTime = (rtInf);

  /* InitializeConditions for UnitDelay: '<S22>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_p = ctrlLoopsTE_P.UnitDelay_X0_g;

  /* InitializeConditions for UnitDelay: '<S1>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_l = ctrlLoopsTE_P.UnitDelay_X0_k;

  /* InitializeConditions for RateLimiter: '<Root>/Rate Limiter' */
  ctrlLoopsTE_DWork.LastMajorTime_i = (rtInf);

  /* InitializeConditions for UnitDelay: '<S8>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f = ctrlLoopsTE_P.UnitDelay_X0_i;

  /* InitializeConditions for UnitDelay: '<S28>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_g = ctrlLoopsTE_P.UnitDelay_X0_j;

  /* InitializeConditions for UnitDelay: '<S30>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lw = ctrlLoopsTE_P.UnitDelay_X0_h;

  /* InitializeConditions for UnitDelay: '<S23>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_d = ctrlLoopsTE_P.UnitDelay_X0_c;

  /* InitializeConditions for UnitDelay: '<S25>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_gv = ctrlLoopsTE_P.UnitDelay_X0_ix;

  /* InitializeConditions for UnitDelay: '<S10>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_h = ctrlLoopsTE_P.UnitDelay_X0_f;

  /* InitializeConditions for UnitDelay: '<S20>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_c = ctrlLoopsTE_P.UnitDelay_X0_b;

  /* InitializeConditions for UnitDelay: '<S24>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_o = ctrlLoopsTE_P.UnitDelay_X0_p;

  /* InitializeConditions for UnitDelay: '<S21>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_pq = ctrlLoopsTE_P.UnitDelay_X0_d;

  /* InitializeConditions for UnitDelay: '<S10>/Unit Delay1' */
  ctrlLoopsTE_DWork.UnitDelay1_DSTATE = ctrlLoopsTE_P.UnitDelay1_X0;

  /* InitializeConditions for UnitDelay: '<S26>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ls = ctrlLoopsTE_P.UnitDelay_X0_l;

  /* InitializeConditions for UnitDelay: '<S17>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_n = ctrlLoopsTE_P.UnitDelay_X0_ph;

  /* InitializeConditions for UnitDelay: '<S34>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_pz = ctrlLoopsTE_P.UnitDelay_X0_m;

  /* InitializeConditions for UnitDelay: '<S11>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_k = ctrlLoopsTE_P.UnitDelay_X0_n;

  /* InitializeConditions for UnitDelay: '<S40>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_e = ctrlLoopsTE_P.UnitDelay_X0_jm;

  /* InitializeConditions for UnitDelay: '<S32>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_b = ctrlLoopsTE_P.UnitDelay_X0_hp;

  /* InitializeConditions for UnitDelay: '<S12>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_py = ctrlLoopsTE_P.UnitDelay_X0_pq;

  /* InitializeConditions for UnitDelay: '<S33>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_li = ctrlLoopsTE_P.UnitDelay_X0_ax;

  /* InitializeConditions for UnitDelay: '<S35>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j3 = ctrlLoopsTE_P.UnitDelay_X0_m5;

  /* InitializeConditions for UnitDelay: '<S37>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ff = ctrlLoopsTE_P.UnitDelay_X0_ll;

  /* InitializeConditions for UnitDelay: '<S16>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_hy = ctrlLoopsTE_P.UnitDelay_X0_ky;

  /* InitializeConditions for UnitDelay: '<S38>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lm = ctrlLoopsTE_P.UnitDelay_X0_e;

  /* InitializeConditions for UnitDelay: '<S39>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ef = ctrlLoopsTE_P.UnitDelay_X0_hx;

  /* InitializeConditions for UnitDelay: '<S41>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lr = ctrlLoopsTE_P.UnitDelay_X0_o;

  /* InitializeConditions for UnitDelay: '<S31>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_bm = ctrlLoopsTE_P.UnitDelay_X0_ai;

  /* InitializeConditions for UnitDelay: '<S19>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_i = ctrlLoopsTE_P.UnitDelay_X0_lv;

  /* InitializeConditions for UnitDelay: '<S42>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f0 = ctrlLoopsTE_P.UnitDelay_X0_lt;

  /* InitializeConditions for UnitDelay: '<S43>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lis = ctrlLoopsTE_P.UnitDelay_X0_ch;

  /* InitializeConditions for UnitDelay: '<S13>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ch = ctrlLoopsTE_P.UnitDelay_X0_gn;

  /* InitializeConditions for UnitDelay: '<S36>/Unit Delay' */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_m = ctrlLoopsTE_P.UnitDelay_X0_cp;
}

void MdlStart(void)
{
  MdlInitialize();

  /* initial state override */
  ctrlLoopsTE_DWork.UnitDelay_DSTATE = 88.9535885629885;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j = 8.6213126537678111;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_p = -0.90293084038273719;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_l = 0.44930289407604906;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f = -0.15662337329503184;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_g = 1.7155822874910882;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lw = 17.305402107687655;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_d = 19.331317960230145;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_gv = 51.257455154567779;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_h = 0.0025592877959398157;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_c = 0.23548206041270703;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_o = 0.0031117404628384637;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_pq = -0.514449999441716;
  ctrlLoopsTE_DWork.UnitDelay1_DSTATE = 0.099817696241459225;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ls = 0.021429200692442585;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_n = 90.66499236205189;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_pz = -1.2969146280120327;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_k = 82.459452277163024;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_e = -0.54942020685508908;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_b = 8.7569192962169069;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_py = 0.00088298897521340246;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_li = -0.0066772276167958861;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_j3 = 1.8860923290681058;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ff = 29.16474681788733;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_hy = 0.22333678194461642;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lm = -0.044397406592729283;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ef = 0.86854090566563258;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lr = 39.450610301132237;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_bm = 0.11034077103533591;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_i = 0.23009997429756654;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_f0 = 0.081115254679140492;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_lis = 1.4502848920858042;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_ch = 35.55180700573311;
  ctrlLoopsTE_DWork.UnitDelay_DSTATE_m = -0.0025293811206239525;
}

void MdlTerminate(void)
{
  ctrlLoopsTE_terminate();
}

RT_MODEL_ctrlLoopsTE *ctrlLoopsTE(void)
{
  ctrlLoopsTE_initialize(1);
  return ctrlLoopsTE_M;
}

/*========================================================================*
 * End of GRT compatible call interface                                   *
 *========================================================================*/
