/*
 * myTEmodel.c
 *
 * Real-Time Workshop code generation for Simulink model "myTEmodel.mdl".
 *
 * Model version              : 1.7
 * Real-Time Workshop version : 7.6  (R2010b)  03-Aug-2010
 * C source code generated on : Sat Oct 18 13:09:56 2014
 *
 * Target selection: grt.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "myTEmodel.h"
#include "myTEmodel_private.h"

/* Block signals (auto storage) */
BlockIO_myTEmodel myTEmodel_B;

/* Continuous states */
ContinuousStates_myTEmodel myTEmodel_X;

/* External inputs (root inport signals with auto storage) */
ExternalInputs_myTEmodel myTEmodel_U;

/* External outputs (root outports fed by signals with auto storage) */
ExternalOutputs_myTEmodel myTEmodel_Y;

/* Real-time model */
RT_MODEL_myTEmodel myTEmodel_M_;
RT_MODEL_myTEmodel *myTEmodel_M = &myTEmodel_M_;

/*
 * This function updates continuous states using the ODE5 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  /* Solver Matrices */
  static const real_T rt_ODE5_A[6] = {
    1.0/5.0, 3.0/10.0, 4.0/5.0, 8.0/9.0, 1.0, 1.0
  };

  static const real_T rt_ODE5_B[6][6] = {
    { 1.0/5.0, 0.0, 0.0, 0.0, 0.0, 0.0 },

    { 3.0/40.0, 9.0/40.0, 0.0, 0.0, 0.0, 0.0 },

    { 44.0/45.0, -56.0/15.0, 32.0/9.0, 0.0, 0.0, 0.0 },

    { 19372.0/6561.0, -25360.0/2187.0, 64448.0/6561.0, -212.0/729.0, 0.0, 0.0 },

    { 9017.0/3168.0, -355.0/33.0, 46732.0/5247.0, 49.0/176.0, -5103.0/18656.0,
      0.0 },

    { 35.0/384.0, 0.0, 500.0/1113.0, 125.0/192.0, -2187.0/6784.0, 11.0/84.0 }
  };

  time_T t = rtsiGetT(si);
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE5_IntgData *id = (ODE5_IntgData *)rtsiGetSolverData(si);
  real_T *y = id->y;
  real_T *f0 = id->f[0];
  real_T *f1 = id->f[1];
  real_T *f2 = id->f[2];
  real_T *f3 = id->f[3];
  real_T *f4 = id->f[4];
  real_T *f5 = id->f[5];
  real_T hB[6];
  int_T i;
  int_T nXc = 50;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);

  /* Save the state values at time t in y, we'll use x as ynew. */
  (void) memcpy(y, x,
                nXc*sizeof(real_T));

  /* Assumes that rtsiSetT and ModelOutputs are up-to-date */
  /* f0 = f(t,y) */
  rtsiSetdX(si, f0);
  myTEmodel_derivatives();

  /* f(:,2) = feval(odefile, t + hA(1), y + f*hB(:,1), args(:)(*)); */
  hB[0] = h * rt_ODE5_B[0][0];
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0]);
  }

  rtsiSetT(si, t + h*rt_ODE5_A[0]);
  rtsiSetdX(si, f1);
  myTEmodel_output(0);
  myTEmodel_derivatives();

  /* f(:,3) = feval(odefile, t + hA(2), y + f*hB(:,2), args(:)(*)); */
  for (i = 0; i <= 1; i++) {
    hB[i] = h * rt_ODE5_B[1][i];
  }

  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0] + f1[i]*hB[1]);
  }

  rtsiSetT(si, t + h*rt_ODE5_A[1]);
  rtsiSetdX(si, f2);
  myTEmodel_output(0);
  myTEmodel_derivatives();

  /* f(:,4) = feval(odefile, t + hA(3), y + f*hB(:,3), args(:)(*)); */
  for (i = 0; i <= 2; i++) {
    hB[i] = h * rt_ODE5_B[2][i];
  }

  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0] + f1[i]*hB[1] + f2[i]*hB[2]);
  }

  rtsiSetT(si, t + h*rt_ODE5_A[2]);
  rtsiSetdX(si, f3);
  myTEmodel_output(0);
  myTEmodel_derivatives();

  /* f(:,5) = feval(odefile, t + hA(4), y + f*hB(:,4), args(:)(*)); */
  for (i = 0; i <= 3; i++) {
    hB[i] = h * rt_ODE5_B[3][i];
  }

  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0] + f1[i]*hB[1] + f2[i]*hB[2] +
                   f3[i]*hB[3]);
  }

  rtsiSetT(si, t + h*rt_ODE5_A[3]);
  rtsiSetdX(si, f4);
  myTEmodel_output(0);
  myTEmodel_derivatives();

  /* f(:,6) = feval(odefile, t + hA(5), y + f*hB(:,5), args(:)(*)); */
  for (i = 0; i <= 4; i++) {
    hB[i] = h * rt_ODE5_B[4][i];
  }

  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0] + f1[i]*hB[1] + f2[i]*hB[2] +
                   f3[i]*hB[3] + f4[i]*hB[4]);
  }

  rtsiSetT(si, tnew);
  rtsiSetdX(si, f5);
  myTEmodel_output(0);
  myTEmodel_derivatives();

  /* tnew = t + hA(6);
     ynew = y + f*hB(:,6); */
  for (i = 0; i <= 5; i++) {
    hB[i] = h * rt_ODE5_B[5][i];
  }

  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0] + f1[i]*hB[1] + f2[i]*hB[2] +
                   f3[i]*hB[3] + f4[i]*hB[4] + f5[i]*hB[5]);
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/* Model output function */
void myTEmodel_output(int_T tid)
{
  if (rtmIsMajorTimeStep(myTEmodel_M)) {
    /* set solver stop time */
    if (!(myTEmodel_M->Timing.clockTick0+1)) {
      rtsiSetSolverStopTime(&myTEmodel_M->solverInfo,
                            ((myTEmodel_M->Timing.clockTickH0 + 1) *
        myTEmodel_M->Timing.stepSize0 * 4294967296.0));
    } else {
      rtsiSetSolverStopTime(&myTEmodel_M->solverInfo,
                            ((myTEmodel_M->Timing.clockTick0 + 1) *
        myTEmodel_M->Timing.stepSize0 + myTEmodel_M->Timing.clockTickH0 *
        myTEmodel_M->Timing.stepSize0 * 4294967296.0));
    }
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(myTEmodel_M)) {
    myTEmodel_M->Timing.t[0] = rtsiGetT(&myTEmodel_M->solverInfo);
  }

  /* Level2 S-Function Block: '<Root>/TE Code' (mytenn) */
  {
    SimStruct *rts = myTEmodel_M->childSfunctions[0];
    sfcnOutputs(rts, 0);
  }

  /* Outport: '<Root>/Out1' */
  myTEmodel_Y.Out1 = myTEmodel_B.TECode[0];

  /* Outport: '<Root>/Out2' */
  myTEmodel_Y.Out2 = myTEmodel_B.TECode[1];

  /* Outport: '<Root>/Out3' */
  myTEmodel_Y.Out3 = myTEmodel_B.TECode[2];

  /* Outport: '<Root>/Out4' */
  myTEmodel_Y.Out4 = myTEmodel_B.TECode[3];

  /* Outport: '<Root>/Out5' */
  myTEmodel_Y.Out5 = myTEmodel_B.TECode[4];

  /* Outport: '<Root>/Out6' */
  myTEmodel_Y.Out6 = myTEmodel_B.TECode[5];

  /* Outport: '<Root>/Out7' */
  myTEmodel_Y.Out7 = myTEmodel_B.TECode[6];

  /* Outport: '<Root>/Out8' */
  myTEmodel_Y.Out8 = myTEmodel_B.TECode[7];

  /* Outport: '<Root>/Out9' */
  myTEmodel_Y.Out9 = myTEmodel_B.TECode[8];

  /* Outport: '<Root>/Out10' */
  myTEmodel_Y.Out10 = myTEmodel_B.TECode[9];

  /* Outport: '<Root>/Out11' */
  myTEmodel_Y.Out11 = myTEmodel_B.TECode[10];

  /* Outport: '<Root>/Out12' */
  myTEmodel_Y.Out12 = myTEmodel_B.TECode[11];

  /* Outport: '<Root>/Out13' */
  myTEmodel_Y.Out13 = myTEmodel_B.TECode[12];

  /* Outport: '<Root>/Out14' */
  myTEmodel_Y.Out14 = myTEmodel_B.TECode[13];

  /* Outport: '<Root>/Out15' */
  myTEmodel_Y.Out15 = myTEmodel_B.TECode[14];

  /* Outport: '<Root>/Out16' */
  myTEmodel_Y.Out16 = myTEmodel_B.TECode[15];

  /* Outport: '<Root>/Out17' */
  myTEmodel_Y.Out17 = myTEmodel_B.TECode[16];

  /* Outport: '<Root>/Out18' */
  myTEmodel_Y.Out18 = myTEmodel_B.TECode[17];

  /* Outport: '<Root>/Out19' */
  myTEmodel_Y.Out19 = myTEmodel_B.TECode[18];

  /* Outport: '<Root>/Out20' */
  myTEmodel_Y.Out20 = myTEmodel_B.TECode[19];

  /* Outport: '<Root>/Out21' */
  myTEmodel_Y.Out21 = myTEmodel_B.TECode[20];

  /* Outport: '<Root>/Out22' */
  myTEmodel_Y.Out22 = myTEmodel_B.TECode[21];

  /* Outport: '<Root>/Out23' */
  myTEmodel_Y.Out23 = myTEmodel_B.TECode[22];

  /* Outport: '<Root>/Out24' */
  myTEmodel_Y.Out24 = myTEmodel_B.TECode[23];

  /* Outport: '<Root>/Out25' */
  myTEmodel_Y.Out25 = myTEmodel_B.TECode[24];

  /* Outport: '<Root>/Out26' */
  myTEmodel_Y.Out26 = myTEmodel_B.TECode[25];

  /* Outport: '<Root>/Out27' */
  myTEmodel_Y.Out27 = myTEmodel_B.TECode[26];

  /* Outport: '<Root>/Out28' */
  myTEmodel_Y.Out28 = myTEmodel_B.TECode[27];

  /* Outport: '<Root>/Out29' */
  myTEmodel_Y.Out29 = myTEmodel_B.TECode[28];

  /* Outport: '<Root>/Out30' */
  myTEmodel_Y.Out30 = myTEmodel_B.TECode[29];

  /* Outport: '<Root>/Out31' */
  myTEmodel_Y.Out31 = myTEmodel_B.TECode[30];

  /* Outport: '<Root>/Out32' */
  myTEmodel_Y.Out32 = myTEmodel_B.TECode[31];

  /* Outport: '<Root>/Out33' */
  myTEmodel_Y.Out33 = myTEmodel_B.TECode[32];

  /* Outport: '<Root>/Out34' */
  myTEmodel_Y.Out34 = myTEmodel_B.TECode[33];

  /* Outport: '<Root>/Out35' */
  myTEmodel_Y.Out35 = myTEmodel_B.TECode[34];

  /* Outport: '<Root>/Out36' */
  myTEmodel_Y.Out36 = myTEmodel_B.TECode[35];

  /* Outport: '<Root>/Out37' */
  myTEmodel_Y.Out37 = myTEmodel_B.TECode[36];

  /* Outport: '<Root>/Out38' */
  myTEmodel_Y.Out38 = myTEmodel_B.TECode[37];

  /* Outport: '<Root>/Out39' */
  myTEmodel_Y.Out39 = myTEmodel_B.TECode[38];

  /* Outport: '<Root>/Out40' */
  myTEmodel_Y.Out40 = myTEmodel_B.TECode[39];

  /* Outport: '<Root>/Out41' */
  myTEmodel_Y.Out41 = myTEmodel_B.TECode[40];

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model update function */
void myTEmodel_update(int_T tid)
{
  /* Level2 S-Function Block: '<Root>/TE Code' (mytenn) */
  {
    SimStruct *rts = myTEmodel_M->childSfunctions[0];
    sfcnUpdate(rts, 0);
    if (ssGetErrorStatus(rts) != (NULL))
      return;
  }

  if (rtmIsMajorTimeStep(myTEmodel_M)) {
    rt_ertODEUpdateContinuousStates(&myTEmodel_M->solverInfo);
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++myTEmodel_M->Timing.clockTick0)) {
    ++myTEmodel_M->Timing.clockTickH0;
  }

  myTEmodel_M->Timing.t[0] = rtsiGetSolverStopTime(&myTEmodel_M->solverInfo);

  {
    /* Update absolute timer for sample time: [0.0005s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick1"
     * and "Timing.stepSize1". Size of "clockTick1" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++myTEmodel_M->Timing.clockTick1)) {
      ++myTEmodel_M->Timing.clockTickH1;
    }

    myTEmodel_M->Timing.t[1] = myTEmodel_M->Timing.clockTick1 *
      myTEmodel_M->Timing.stepSize1 + myTEmodel_M->Timing.clockTickH1 *
      myTEmodel_M->Timing.stepSize1 * 4294967296.0;
  }

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Derivatives for root system: '<Root>' */
void myTEmodel_derivatives(void)
{
  /* Level2 S-Function Block: '<Root>/TE Code' (mytenn) */
  {
    SimStruct *rts = myTEmodel_M->childSfunctions[0];
    real_T *sfcndX_fx = (real_T *) &((StateDerivatives_myTEmodel *)
      myTEmodel_M->ModelData.derivs)->TECode_CSTATE[0];
    ssSetdX(rts, sfcndX_fx);
    sfcnDerivatives(rts);
    if (ssGetErrorStatus(rts) != (NULL))
      return;
  }
}

/* Model initialize function */
void myTEmodel_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)myTEmodel_M, 0,
                sizeof(RT_MODEL_myTEmodel));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&myTEmodel_M->solverInfo,
                          &myTEmodel_M->Timing.simTimeStep);
    rtsiSetTPtr(&myTEmodel_M->solverInfo, &rtmGetTPtr(myTEmodel_M));
    rtsiSetStepSizePtr(&myTEmodel_M->solverInfo, &myTEmodel_M->Timing.stepSize0);
    rtsiSetdXPtr(&myTEmodel_M->solverInfo, &myTEmodel_M->ModelData.derivs);
    rtsiSetContStatesPtr(&myTEmodel_M->solverInfo,
                         &myTEmodel_M->ModelData.contStates);
    rtsiSetNumContStatesPtr(&myTEmodel_M->solverInfo,
      &myTEmodel_M->Sizes.numContStates);
    rtsiSetErrorStatusPtr(&myTEmodel_M->solverInfo, (&rtmGetErrorStatus
      (myTEmodel_M)));
    rtsiSetRTModelPtr(&myTEmodel_M->solverInfo, myTEmodel_M);
  }

  rtsiSetSimTimeStep(&myTEmodel_M->solverInfo, MAJOR_TIME_STEP);
  myTEmodel_M->ModelData.intgData.y = myTEmodel_M->ModelData.odeY;
  myTEmodel_M->ModelData.intgData.f[0] = myTEmodel_M->ModelData.odeF[0];
  myTEmodel_M->ModelData.intgData.f[1] = myTEmodel_M->ModelData.odeF[1];
  myTEmodel_M->ModelData.intgData.f[2] = myTEmodel_M->ModelData.odeF[2];
  myTEmodel_M->ModelData.intgData.f[3] = myTEmodel_M->ModelData.odeF[3];
  myTEmodel_M->ModelData.intgData.f[4] = myTEmodel_M->ModelData.odeF[4];
  myTEmodel_M->ModelData.intgData.f[5] = myTEmodel_M->ModelData.odeF[5];
  myTEmodel_M->ModelData.contStates = ((real_T *) &myTEmodel_X);
  rtsiSetSolverData(&myTEmodel_M->solverInfo, (void *)
                    &myTEmodel_M->ModelData.intgData);
  rtsiSetSolverName(&myTEmodel_M->solverInfo,"ode5");
  myTEmodel_M->solverInfoPtr = (&myTEmodel_M->solverInfo);

  /* Initialize timing info */
  {
    int_T *mdlTsMap = myTEmodel_M->Timing.sampleTimeTaskIDArray;
    mdlTsMap[0] = 0;
    mdlTsMap[1] = 1;
    myTEmodel_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    myTEmodel_M->Timing.sampleTimes = (&myTEmodel_M->Timing.sampleTimesArray[0]);
    myTEmodel_M->Timing.offsetTimes = (&myTEmodel_M->Timing.offsetTimesArray[0]);

    /* task periods */
    myTEmodel_M->Timing.sampleTimes[0] = (0.0);
    myTEmodel_M->Timing.sampleTimes[1] = (0.0005);

    /* task offsets */
    myTEmodel_M->Timing.offsetTimes[0] = (0.0);
    myTEmodel_M->Timing.offsetTimes[1] = (0.0);
  }

  rtmSetTPtr(myTEmodel_M, &myTEmodel_M->Timing.tArray[0]);

  {
    int_T *mdlSampleHits = myTEmodel_M->Timing.sampleHitArray;
    mdlSampleHits[0] = 1;
    mdlSampleHits[1] = 1;
    myTEmodel_M->Timing.sampleHits = (&mdlSampleHits[0]);
  }

  rtmSetTFinal(myTEmodel_M, -1);
  myTEmodel_M->Timing.stepSize0 = 0.0005;
  myTEmodel_M->Timing.stepSize1 = 0.0005;
  myTEmodel_M->solverInfoPtr = (&myTEmodel_M->solverInfo);
  myTEmodel_M->Timing.stepSize = (0.0005);
  rtsiSetFixedStepSize(&myTEmodel_M->solverInfo, 0.0005);
  rtsiSetSolverMode(&myTEmodel_M->solverInfo, SOLVER_MODE_SINGLETASKING);

  /* block I/O */
  myTEmodel_M->ModelData.blockIO = ((void *) &myTEmodel_B);
  (void) memset(((void *) &myTEmodel_B), 0,
                sizeof(BlockIO_myTEmodel));

  /* parameters */
  myTEmodel_M->ModelData.defaultParam = ((real_T *)&myTEmodel_P);

  /* states (continuous) */
  {
    real_T *x = (real_T *) &myTEmodel_X;
    myTEmodel_M->ModelData.contStates = (x);
    (void) memset((void *)&myTEmodel_X, 0,
                  sizeof(ContinuousStates_myTEmodel));
  }

  /* external inputs */
  myTEmodel_M->ModelData.inputs = (((void*)&myTEmodel_U));
  (void) memset((void *)&myTEmodel_U, 0,
                sizeof(ExternalInputs_myTEmodel));

  /* external outputs */
  myTEmodel_M->ModelData.outputs = (&myTEmodel_Y);
  (void) memset((void *)&myTEmodel_Y, 0,
                sizeof(ExternalOutputs_myTEmodel));

  /* child S-Function registration */
  {
    RTWSfcnInfo *sfcnInfo = &myTEmodel_M->NonInlinedSFcns.sfcnInfo;
    myTEmodel_M->sfcnInfo = (sfcnInfo);
    rtssSetErrorStatusPtr(sfcnInfo, (&rtmGetErrorStatus(myTEmodel_M)));
    rtssSetNumRootSampTimesPtr(sfcnInfo, &myTEmodel_M->Sizes.numSampTimes);
    rtssSetTPtrPtr(sfcnInfo, &rtmGetTPtr(myTEmodel_M));
    rtssSetTStartPtr(sfcnInfo, &rtmGetTStart(myTEmodel_M));
    rtssSetTFinalPtr(sfcnInfo, &rtmGetTFinal(myTEmodel_M));
    rtssSetTimeOfLastOutputPtr(sfcnInfo, &rtmGetTimeOfLastOutput(myTEmodel_M));
    rtssSetStepSizePtr(sfcnInfo, &myTEmodel_M->Timing.stepSize);
    rtssSetStopRequestedPtr(sfcnInfo, &rtmGetStopRequested(myTEmodel_M));
    rtssSetDerivCacheNeedsResetPtr(sfcnInfo,
      &myTEmodel_M->ModelData.derivCacheNeedsReset);
    rtssSetZCCacheNeedsResetPtr(sfcnInfo,
      &myTEmodel_M->ModelData.zCCacheNeedsReset);
    rtssSetBlkStateChangePtr(sfcnInfo, &myTEmodel_M->ModelData.blkStateChange);
    rtssSetSampleHitsPtr(sfcnInfo, &myTEmodel_M->Timing.sampleHits);
    rtssSetPerTaskSampleHitsPtr(sfcnInfo, &myTEmodel_M->Timing.perTaskSampleHits);
    rtssSetSimModePtr(sfcnInfo, &myTEmodel_M->simMode);
    rtssSetSolverInfoPtr(sfcnInfo, &myTEmodel_M->solverInfoPtr);
  }

  myTEmodel_M->Sizes.numSFcns = (1);

  /* register each child */
  {
    (void) memset((void *)&myTEmodel_M->NonInlinedSFcns.childSFunctions[0], 0,
                  1*sizeof(SimStruct));
    myTEmodel_M->childSfunctions =
      (&myTEmodel_M->NonInlinedSFcns.childSFunctionPtrs[0]);
    myTEmodel_M->childSfunctions[0] =
      (&myTEmodel_M->NonInlinedSFcns.childSFunctions[0]);

    /* Level2 S-Function Block: myTEmodel/<Root>/TE Code (mytenn) */
    {
      SimStruct *rts = myTEmodel_M->childSfunctions[0];

      /* timing info */
      time_T *sfcnPeriod = myTEmodel_M->NonInlinedSFcns.Sfcn0.sfcnPeriod;
      time_T *sfcnOffset = myTEmodel_M->NonInlinedSFcns.Sfcn0.sfcnOffset;
      int_T *sfcnTsMap = myTEmodel_M->NonInlinedSFcns.Sfcn0.sfcnTsMap;
      (void) memset((void*)sfcnPeriod, 0,
                    sizeof(time_T)*1);
      (void) memset((void*)sfcnOffset, 0,
                    sizeof(time_T)*1);
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);

      /* Set up the mdlInfo pointer */
      {
        ssSetBlkInfo2Ptr(rts, &myTEmodel_M->NonInlinedSFcns.blkInfo2[0]);
      }

      ssSetRTWSfcnInfo(rts, myTEmodel_M->sfcnInfo);

      /* Allocate memory of model methods 2 */
      {
        ssSetModelMethods2(rts, &myTEmodel_M->NonInlinedSFcns.methods2[0]);
      }

      /* Allocate memory of model methods 3 */
      {
        ssSetModelMethods3(rts, &myTEmodel_M->NonInlinedSFcns.methods3[0]);
      }

      /* inputs */
      {
        _ssSetNumInputPorts(rts, 1);
        ssSetPortInfoForInputs(rts,
          &myTEmodel_M->NonInlinedSFcns.Sfcn0.inputPortInfo[0]);

        /* port 0 */
        {
          real_T const **sfcnUPtrs = (real_T const **)
            &myTEmodel_M->NonInlinedSFcns.Sfcn0.UPtrs0;
          sfcnUPtrs[0] = &myTEmodel_U.In1;
          sfcnUPtrs[1] = &myTEmodel_U.In2;
          sfcnUPtrs[2] = &myTEmodel_U.In3;
          sfcnUPtrs[3] = &myTEmodel_U.In4;
          sfcnUPtrs[4] = &myTEmodel_U.In5;
          sfcnUPtrs[5] = &myTEmodel_U.In6;
          sfcnUPtrs[6] = &myTEmodel_U.In7;
          sfcnUPtrs[7] = &myTEmodel_U.In8;
          sfcnUPtrs[8] = &myTEmodel_U.In9;
          sfcnUPtrs[9] = &myTEmodel_U.In10;
          sfcnUPtrs[10] = &myTEmodel_U.In11;
          sfcnUPtrs[11] = &myTEmodel_U.In12;
          ssSetInputPortSignalPtrs(rts, 0, (InputPtrsType)&sfcnUPtrs[0]);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 12);
        }
      }

      /* outputs */
      {
        ssSetPortInfoForOutputs(rts,
          &myTEmodel_M->NonInlinedSFcns.Sfcn0.outputPortInfo[0]);
        _ssSetNumOutputPorts(rts, 1);

        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 41);
          ssSetOutputPortSignal(rts, 0, ((real_T *) myTEmodel_B.TECode));
        }
      }

      /* states */
      ssSetContStates(rts, &myTEmodel_X.TECode_CSTATE[0]);

      /* path info */
      ssSetModelName(rts, "TE Code");
      ssSetPath(rts, "myTEmodel/TE Code");
      ssSetRTModel(rts,myTEmodel_M);
      ssSetParentSS(rts, (NULL));
      ssSetRootSS(rts, rts);
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        mxArray **sfcnParams = (mxArray **)
          &myTEmodel_M->NonInlinedSFcns.Sfcn0.params;
        ssSetSFcnParamsCount(rts, 2);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);
        ssSetSFcnParam(rts, 0, (mxArray*)&myTEmodel_P.TECode_P1_Size[0]);
        ssSetSFcnParam(rts, 1, (mxArray*)&myTEmodel_P.TECode_P2_Size[0]);
      }

      /* registration */
      mytenn(rts);
      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.0);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 0;

      /* set compiled values of dynamic vector attributes */
      ssSetNumNonsampledZCs(rts, 0);

      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);

      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
    }
  }

  /* initial state override */
  {
    static const real_T rtcs0_TECode_CSTATE[50] = {
      9.8330595956334914
      , 15.818863237372002
      , 3.2449133422333909
      , 0.72149003572823445
      , 5.0781763108239533
      , 2.3178125529229834
      , 290.7649079400237
      , 33.409493306315
      , 2.6191862636065864
      , 56.073789256691747
      , 90.195885487534966
      , 18.5135888527456
      , 0.47022360194109875
      , 3.522842312312024
      , 1.6095821373257755
      , 106.80826915979679
      , 9.3475249501736766
      , 0.62946367282625459
      , 0.45779081107908093
      , 0.0084950984680591084
      , 0.96277655113538652
      , 0.027263648701851616
      , 0.15461456381467636
      , 0.068579692654859775
      , 87.101149650935142
      , 7.9010800034916269
      , 0.36380501717556729
      , 94.643460744818782
      , 88.8638153761146
      , 57.599219161550714
      , 40.561843547239384
      , 12.505104041822435
      , 4.1329717355393649
      , 21.443863597176012
      , 1.1207348491128424
      , 0.63528095070907153
      , 101.88085116273128
      , 45.57033615920578
      , 88.953896138282914
      , 8.6198530392123285
      , 19.327542107010533
      , 51.259607609268691
      , 76.948840664730483
      , 8.7628332164574463
      , 29.163675060014086
      , 39.449283086245373
      , 0.99999999999999634
      , 35.578231231755311
      , 89.224588557102663
      , 99.999999999999986
    };

    (void) memcpy(&myTEmodel_X.TECode_CSTATE[0], rtcs0_TECode_CSTATE,
                  50*sizeof(real_T));
  }
}

/* Model terminate function */
void myTEmodel_terminate(void)
{
  /* Level2 S-Function Block: '<Root>/TE Code' (mytenn) */
  {
    SimStruct *rts = myTEmodel_M->childSfunctions[0];
    sfcnTerminate(rts);
  }
}

/*========================================================================*
 * Start of GRT compatible call interface                                 *
 *========================================================================*/

/* Solver interface called by GRT_Main */
#ifndef USE_GENERATED_SOLVER

void rt_ODECreateIntegrationData(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

void rt_ODEDestroyIntegrationData(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

void rt_ODEUpdateContinuousStates(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

#endif

void MdlOutputs(int_T tid)
{
  myTEmodel_output(tid);
}

void MdlUpdate(int_T tid)
{
  myTEmodel_update(tid);
}

void MdlInitializeSizes(void)
{
  myTEmodel_M->Sizes.numContStates = (50);/* Number of continuous states */
  myTEmodel_M->Sizes.numY = (41);      /* Number of model outputs */
  myTEmodel_M->Sizes.numU = (12);      /* Number of model inputs */
  myTEmodel_M->Sizes.sysDirFeedThru = (1);/* The model is direct feedthrough */
  myTEmodel_M->Sizes.numSampTimes = (2);/* Number of sample times */
  myTEmodel_M->Sizes.numBlocks = (42); /* Number of blocks */
  myTEmodel_M->Sizes.numBlockIO = (1); /* Number of block outputs */
  myTEmodel_M->Sizes.numBlockPrms = (24);/* Sum of parameter "widths" */
}

void MdlInitializeSampleTimes(void)
{
}

void MdlInitialize(void)
{
  /* Level2 S-Function Block: '<Root>/TE Code' (mytenn) */
  {
    SimStruct *rts = myTEmodel_M->childSfunctions[0];
    sfcnInitializeConditions(rts);
    if (ssGetErrorStatus(rts) != (NULL))
      return;
  }
}

void MdlStart(void)
{
  /* Level2 S-Function Block: '<Root>/TE Code' (mytenn) */
  {
    SimStruct *rts = myTEmodel_M->childSfunctions[0];
    sfcnStart(rts);
    if (ssGetErrorStatus(rts) != (NULL))
      return;
  }

  MdlInitialize();

  /* initial state override */
  {
    static const real_T rtcs0_TECode_CSTATE[50] = {
      9.8330595956334914
      , 15.818863237372002
      , 3.2449133422333909
      , 0.72149003572823445
      , 5.0781763108239533
      , 2.3178125529229834
      , 290.7649079400237
      , 33.409493306315
      , 2.6191862636065864
      , 56.073789256691747
      , 90.195885487534966
      , 18.5135888527456
      , 0.47022360194109875
      , 3.522842312312024
      , 1.6095821373257755
      , 106.80826915979679
      , 9.3475249501736766
      , 0.62946367282625459
      , 0.45779081107908093
      , 0.0084950984680591084
      , 0.96277655113538652
      , 0.027263648701851616
      , 0.15461456381467636
      , 0.068579692654859775
      , 87.101149650935142
      , 7.9010800034916269
      , 0.36380501717556729
      , 94.643460744818782
      , 88.8638153761146
      , 57.599219161550714
      , 40.561843547239384
      , 12.505104041822435
      , 4.1329717355393649
      , 21.443863597176012
      , 1.1207348491128424
      , 0.63528095070907153
      , 101.88085116273128
      , 45.57033615920578
      , 88.953896138282914
      , 8.6198530392123285
      , 19.327542107010533
      , 51.259607609268691
      , 76.948840664730483
      , 8.7628332164574463
      , 29.163675060014086
      , 39.449283086245373
      , 0.99999999999999634
      , 35.578231231755311
      , 89.224588557102663
      , 99.999999999999986
    };

    (void) memcpy(&myTEmodel_X.TECode_CSTATE[0], rtcs0_TECode_CSTATE,
                  50*sizeof(real_T));
  }
}

void MdlTerminate(void)
{
  myTEmodel_terminate();
}

RT_MODEL_myTEmodel *myTEmodel(void)
{
  myTEmodel_initialize(1);
  return myTEmodel_M;
}

/*========================================================================*
 * End of GRT compatible call interface                                   *
 *========================================================================*/
